/*
    --------------------------------------------------------------------
                             RMF RDS Widget
                Copyright (c) 2007-2012 Jacek Jędrzejewski
                    http://www.jacek.jedrzejewski.name/
                          All rights reserved.
    --------------------------------------------------------------------

    This file is part of RMF RDS Widget.
*/

var $ = Sizzle;

var Rds = new Base;

Rds.extend({
    constructor: null,
    version: '8.5',
    debug: false,
    
    currentStation: 5, // RMF FM
    lastSongId: 0,
    info: {  },
    currentTst: 0,
    fakty: 'no',
    song: '',
    stationList: [],
    
    stations: [
        {id: 5,   name: 'RMF FM',               key: 'rmffm',               slug: 'rmf-fm',                     stream: 'rmf',              slogan: 'Radio numer 1 w Polsce. Największa i najpopularniejsza stacja muzyczno-informacyjna. Prezentuje aktualne hity i największe przeboje ostatnich 30 lat oraz najistotniejsze Fakty.'},
        {id: 7,   name: 'RMF Classic',          key: 'rmfclassic',          slug: 'rmf-classic',                stream: 'classic',          slogan: 'Muzyka z klasą - niezwykłe zestawienie muzyki klasycznej i filmowej. Arcydzieła, które nuci cały świat. Informacje ze świata kultury i sztuki podane bez zadęcia.'},
        {id: 6,   name: 'RMF Maxxx',            key: 'rmfmaxxx',            slug: 'rmf-maxxx',                  stream: 'maxxx',            slogan: 'Pop, Dance, R\'N\'B, Hip-Hop i Rock - najlepszy mix, świetni DJ-e, niepowtarzalna atmosfera! Wszystko to, co najlepsze w nowej muzie.'},
        {id: 94,  name: 'RMF 2',                key: 'rmf2',                slug: 'rmf-2',                      stream: 'rmf2',             slogan: 'Posłuchaj najlepszej Muzyki pop w całym Internecie. Od króla Michaela Jacksona poprzez królową Madonnę, księżniczkę Britney Spears aż po ich spadkobierczynię Lady Gagę. Witamy w królestwie popu!'},
        {id: 95,  name: 'RMF 3',                key: 'rmf3',                slug: 'rmf-3',                      stream: 'rmf3',             slogan: 'Najlepsza muzyka z gitarą w ręku. Od Bon Jovi po The killers, od U2 po Coldplay. Nie zabraknie tu również polskiej czołówki na czele z Myslovitz, Perfect, ONA czy Wilkami.'},
        {id: 96,  name: 'RMF 4',                key: 'rmf4',                slug: 'rmf-4',                      stream: 'rmf4',             slogan: 'Gramy największe hity Dance i R&B przez 24 godziny na dobę. Dawkę pozytywnej energii dostarczą Wam Rihanna, Black Eyed Peas, Beyonce, ATB, Katy Perry i wielu, wielu innych. RMF 4 - tu rządzi rytm!'},
        {id: 97,  name: 'RMF 5',                key: 'rmf5',                slug: 'rmf-5',                      stream: 'rmf5',             slogan: 'Największe przeboje ostatnich dekad w łagodnych klimatach. Bryan Adams, Chris Rea, De Mono, Aerosmith, Phil Collins, Celinie Dion i wielu innych. RMF 5 - największe przeboje, legendarni artyści.'},
        {id: 18,  name: 'eLO RMF',              key: 'rmfelo',              slug: 'elo-rmf',                    stream: 'elo',              slogan: 'Licealny głos w Waszych domach! Ciekawochy muzyczne, info o koncertach i imprezach, audycje z przymrużeniem oka, ale także dyskusje na poważne tematy. A przez całą dobę muza, także wybrana przez licealistów. eLO RMF - to się robi po szkole.'},
        {id: 82,  name: '20 lat RMF FM',        key: 'rmf20lat',            slug: '20-lat-rmf-fm',              stream: '20lat',            slogan: 'Muzyczna historia stacji numer 1 w Polsce. Największe przeboje, najwybitniejsi artyści, archiwalne materiały. Radio of my life - RMF FM!'},
        {id: 48,  name: 'RMF 50s',              key: 'rmf50s',              slug: 'rmf-50s',                    stream: '50s',              slogan: 'Muzyczna podróż po latach 50. Król Elvis i inni wielcy artyści, m.in. Little Richard, Frank Sinatra, Buddy Holly, Chuck Berry czy Everly Brothers. Odkryj czego wtedy słuchał świat.'},
        {id: 44,  name: 'RMF 60s',              key: 'rmf60s',              slug: 'rmf-60s',                    stream: '60s',              slogan: 'Muzyczny przewodnik po latach 60. Poczuj klimat epoki dzieci kwiatów. Od rock and rolla poprzez funk, soul, blues, aż po psychodelicznego rocka.'},
        {id: 45,  name: 'RMF 70s',              key: 'rmf70s',              slug: 'rmf-70s',                    stream: '70s',              slogan: 'Wszystkie muzyczne odcienie tej wyjątkowej dekady. Tu usłyszysz gitarowe klasyki, popowe przeboje i poczujesz gorączkę sobotniej nocy. Zabawa gwarantowana.'},
        {id: 108, name: 'RMF 70s Disco',        key: 'rmf70sdisco',         slug: 'rmf-70s-disco',              stream: '70sdisco',         slogan: 'Gorączka sobotniej nocy 24 godziny na dobę, siedem dni w tygodniu. Tu impreza nigdy się nie kończy. Poczuj pulsujący pod skórą rytm największych tanecznych przebojów lat 70. Uwaga! Słuchanie tego radia może powodować niekontrolowane ruchy rękami i nogami!'},
        {id: 25,  name: 'RMF 80s',              key: 'rmf80s',              slug: 'rmf-80s',                    stream: '80s',              slogan: 'Kanał poświęcony w całości wyjątkowej dla muzyki dekadzie lat 80. Największe hity, które przetrwały do dziś oraz przeboje odkurzone po latach.'},
        {id: 109, name: 'RMF 80s Disco',        key: 'rmf80sdisco',         slug: 'rmf-80s-disco',              stream: '80sdisco',         slogan: 'To radio nigdy nie śpi. Największe taneczne hity tej wyjątkowej dekady. Modern Talking, Bad Boys Blue, Savage, Sabrina, Sandra, Koto, Laserdance… Młodzieży ! Tak bawili się Wasi rodzicie. Rodzice! Przypomnijcie sobie lata szalonej zabawy na prywatkach i dyskotekach.'},
        {id: 46,  name: 'RMF 90s',              key: 'rmf90s',              slug: 'rmf-90s',                    stream: '90s',              slogan: 'Największe przeboje tej niezwykle eklektycznej dekady. Usłyszysz tu polskie i światowe gwiazdy wszystkich gatunków muzycznych.'},
        {id: 81,  name: 'RMF 2000',             key: 'rmf2000',             slug: 'rmf-2000',                   stream: '2000',             slogan: 'Największe przeboje ostatnich 10 lat. Wśród gwiazd między innymi Nelly Furtado, Rihanna, Black Eyed Peas, Madonna, Kasia Kowalska, Wilki i Feel. Posłuchaj jak brzmi pierwsza dekada XXI wieku.'},
        {id: 28,  name: 'RMF Alternatywa',      key: 'rmfalternatywa',      slug: 'rmf-alternatywa',            stream: 'alternatywa',      slogan: 'Bez muzycznych granic, bez oglądania się na listy przebojów. Wreszcie masz Alternatywę.'},
        {id: 91,  name: 'RMF Audioriver',       key: 'rmfaudioriver',       slug: 'rmf-audioriver',             stream: 'audioriver',       slogan: 'RMF Audioriver, to radio jednego z największych polskich festiwali z muzyką elektroniczną. Słońce, plaża i beat, to najlepsza recepta na wakacyjną zabawę. Tu poznasz twórczość wykonawców tej niepowtarzalnej imprezy. Wskocz do rzeki najlepszej elektroniki!'},
        {id: 43,  name: 'RMF Baby',             key: 'rmfbaby',             slug: 'rmf-baby',                   stream: 'baby',             slogan: 'Stacja dla naszych najmłodszych słuchaczy. Fasolki, Akademia Pana Kleksa i najnowsze dziecięce przeboje. Muzyczna zabawa na cały dzień.'},
        {id: 77,  name: 'RMF Beatlemania',      key: 'rmfbeatlemania',      slug: 'rmf-beatlemania',            stream: 'beatlemania',      slogan: 'W "Hard Day\'s Night" kiedy "All You Need is Love" weź przyjaciół "Come Together" i przybądź na Abbey Road na spotkanie z The Beatles. Po prostu "Let It Be".'},
        {id: 39,  name: 'RMF Blues',            key: 'rmfblues',            slug: 'rmf-blues',                  stream: 'blues',            slogan: 'Na początku był blues... i do dziś nie ma sobie równych. Tutaj usłyszysz mistrzów gatunku oraz młodych, dzięki którym ta muzyka wciąż ma się świetnie. Blues w każdym kolorze i nastroju. Poczuj go!'},
        {id: 12,  name: 'RMF Bravo',            key: 'rmfbravo',            slug: 'rmf-bravo',                  stream: 'bravo',            slogan: 'Stacja przygotowywana we współpracy z magazynem Bravo. Tylko wielkie gwiazdy i piosenki ze szczytów list przebojów. Najlepsza muzyka dla nastolatków.'},
        {id: 67,  name: 'RMF Celtic',           key: 'rmfceltic',           slug: 'rmf-celtic',                 stream: 'celtic',           slogan: 'Fáilte go hÉireann - Witaj w zielonej stacji. Poczuj klimat zielonych wzgórz i gwarnych pubów. Najbarwniejsi artyści ze Szmaragdowej Wyspy zabiorą Cię w samo serce celtyckiego świata. Włącz i posłuchaj przy pincie szlachetnego trunku.'},
        {id: 11,  name: 'RMF Chillout',         key: 'rmfchillout',         slug: 'rmf-chillout',               stream: 'chillout',         slogan: 'Odprężenie przy stonowanej muzyce elektronicznej. Wyjątkowy klimat tworzą dla Was m.in. Air, Moby, Morcheeba i Massive Attack.'},
        {id: 85,  name: 'RMF Chopin',           key: 'rmfchopin',           slug: 'rmf-chopin',                 stream: 'chopin',           slogan: 'Spotkaj sie z twórczością największego poety fortepianu. Mazurki, polonezy, walce i wiele innych kompozycji Fryderyka Chopina w jednym miejscu, tylko w najlepszym wykonaniu.'},
        {id: 2,   name: 'RMF Classic Rock',     key: 'rmfclassicrock',      slug: 'rmf-classic-rock',           stream: 'classicrock',      slogan: 'Absolutny kanon muzyki rockowej. The Beatles, Pink Floyd, The Rolling Stones, Queen, U2 i inni wielcy klasycy. Te piosenki tworzyły pasjonującą historię rocka od lat 60. do 90.'},
        {id: 29,  name: 'RMF Club',             key: 'rmfclub',             slug: 'rmf-club',                   stream: 'club',             slogan: 'Tutaj weekend trwa cały tydzień! Muzyka klubowa od najlepszej strony - tłuste bity z całego świata, przyszłe mega hity, super nowości i klubowe klasyki. Przebrał i wybrał dla Was DJ ADHD.'},
        {id: 50,  name: 'RMF Club Breaks',      key: 'rmfclubbreaks',       slug: 'rmf-club-breaks',            stream: 'clubbreaks',       slogan: 'Co było pierwsze - house czy breaks? Komu przeskoczyła na płycie igła, łamiąc równy bit 1-2-3-4? Któż to wie? Tutaj możesz usłyszeć jak pojemnym i niesłychanie energetycznym gatunkiem są popularne "brejki".'},
        {id: 70,  name: 'RMF Cover',            key: 'rmfcover',            slug: 'rmf-cover',                  stream: 'cover',            slogan: 'RMF Cover to przeboje do potęgi drugiej. Myślałeś, że wiesz już wszystko o muzyce? Ta stacja Cię zaskoczy. Elvis Presley w wersji reggae, Rihanna na ostro, Metallica w rytmie R&B, Michael Jackson kontra Al Yankovic...'},
        {id: 53,  name: 'RMF Cuba',             key: 'rmfcuba',             slug: 'rmf-cuba',                   stream: 'cuba',             slogan: 'Gorące rytmy prosto z serca Karaibów. Słońce, plaża i taniec zapisane w nutach salsy, bachaty i reagettonu. Twoje biodra oszaleją!'},
        {id: 3,   name: 'RMF Dance',            key: 'rmfdance',            slug: 'rmf-dance',                  stream: 'dance',            slogan: 'Taneczne hity bez ograniczeń! Dyskotekowe nowości i klasyka gatunku z lat 90. ATB, Bob Sinclar, Faithless, Sylver i inni władcy parkietów. Włącz się do zabawy!'},
        {id: 31,  name: 'RMF Depeche Mode',     key: 'rmfdepechemode',      slug: 'rmf-depeche-mode',           stream: 'depechemode',      slogan: 'Kultowy zespół teraz ma swoje radio. A w nim wszystko, co ważne dla fanów i nie tylko. Depeche Mode zapraszają w muzyczną podróż.'},
        {id: 26,  name: 'RMF Electro Shockwave',key: 'rmfelectroshockwave', slug: 'rmf-electro-schockwave',     stream: 'electroshockwave', slogan: 'Z tajemniczym uśmiechem Kota z Cheshire, Tom Tylor prowadzi głęboko w labirynt alternatywnej muzyki elektronicznej. Fenomen Depeche Mode, synthpop i EBM - oto Wasz nowy wspaniały świat.'},
        {id: 35,  name: 'RMF Extra',            key: 'rmfextra',            slug: 'rmf-extra',                  stream: 'extra',            slogan: 'Największe gwiazdy w RMF Extra. Blaski i cienie sławy, wyjątkowa muzyka, ekskluzywne wywiady. Na spotkania z gwiazdami zapraszają Marta Grzywacz i Piotr Jaworski.'},
        {id: 56,  name: 'RMF Flamenco',         key: 'rmfflamenco',         slug: 'rmf-flamenco',               stream: 'flamenco',         slogan: 'Pasja w muzyce, śpiewie, tańcu i w życiu. Od klasyki gatunku, przez nuevo flamenco po nowe, klubowe brzmienia. Flamenco - hiszpańska pasja rodem z Andaluzji.'},
        {id: 69,  name: 'RMF FMF',              key: 'rmffmf',              slug: 'rmf-fmf',                    stream: 'fmf',              slogan: 'Festiwal Muzyki Filmowej. Tu posłuchacie muzyki filmowej kompozytorów, których twórczość zabrzmiała podczas tegorocznej edycji, w tym niezapomnianych utworów z takich filmów jak "Piraci z Karaibów: Klątwa Czarnej Perły" czy "Czas Honoru" i wielu innych.'},
        {id: 90,  name: 'RMF Football',         key: 'rmffootball',         slug: 'rmf-football',               stream: 'football',         slogan: 'Czasem nadchodzi przerwa w meczu albo - co gorsza - między meczami. Właśnie dlatego dla wszystkich fanów piłki nożnej stworzyliśmy stację RMF Football. Usłyszycie tu przeboje finałów Mistrzostw Świata i Europy, piłkarskie hity, hymny, kawałki z futbolowych gier i reklam. Bo bramki są dwie, a stacja jest jedna!'},
        {id: 54,  name: 'RMF Francais',         key: 'rmffrancais',         slug: 'rmf-francais',               stream: 'francais',          slogan: 'Największe klasyki i współczesne przeboje w języku Moliera. Od Edith Piaf i Charlesa Aznavoura, po Celine Dion i Carlę Bruni. Szeroki przegląd francuskiej piosenki, w każdym stylu i nastroju. Vive la France!'},
        {id: 15,  name: 'RMF Gold',             key: 'rmfgold',             slug: 'rmf-gold',                   stream: 'gold',             slogan: 'Przeboje, do których zawsze warto wracać. Klasyka lat 60, 70 i 80. Niezapomniane melodie i największe gwiazdy: Tina Turner, Beatles, Queen, Abba, Maryla Rodowicz, Czerwone Gitary i Lady Pank.'},
        {id: 64,  name: 'RMF Groove',           key: 'rmfgroove',           slug: 'rmf-groove',                 stream: 'groove',           slogan: 'Pulsujący pod skórą rytm, który sprawi, że nie usiedzisz w miejscu, a zamykając oczy przeniesiesz się w świat dyskotek, ulic San Francisco, atmosfery nocnych klubów i... nastrojowych sypialni.'},
        {id: 68,  name: 'RMF Grunge',           key: 'rmfgrunge',           slug: 'rmf-grunge',                 stream: 'grunge',           slogan: 'Stacja, której serce bije w Seattle. Bunt, flanelowa koszula i wytarte dżinsy. Posłuchaj pionierów - Nirvany, Pearl Jam, Soundgarden i ich następców. Przekonaj się, że Grunge is still Alive!'},
        {id: 32,  name: 'RMF Hard & Heavy',     key: 'rmfhardandheavy',     slug: 'rmf-hard-and-heavy',         stream: 'hardheavy',        slogan: 'Propozycja dla miłośników ostrych, heavyrockowych brzmień. Absolutny kanon gatunku - 30 lat historii muzyki hard n\' heavy, od korzeni heavy metalu, przez style pokrewne po klasyczny thrash. Stay heavy!'},
        {id: 37,  name: 'RMF Hip Hop',          key: 'rmfhiphop',           slug: 'rmf-hip-hop',                stream: 'hiphop',           slogan: 'Subiektywny przegląd kultury HIP HOP - najlepsi raperzy i producenci, solidne flowy i bity uzbrojone w funk i jazz. O.S.T.R., Łona, De La Soul, A Tribe Called Quest, The Roots, Guru i inni. Jednym słowem tłusto!'},
        {id: 27,  name: 'RMF HOT New',          key: 'rmfhotnew',           slug: 'rmf-how-new',                stream: 'hotnew',           slogan: 'Najciekawsze i najbardziej aktualne muzyczne nowości. Sprawdź, co za chwilę stanie się wielkim przebojem.'},
        {id: 66,  name: 'RMF Kalinka',          key: 'rmfkalinka',          slug: 'rmf-kalinka',                stream: 'kalinka',          slogan: 'RMF Kalinka to muzyka dla prawdziwych kozaków. Posłuchaj jak barwne i niezwykłe są dźwięki zza wschodniej granicy. Największe przeboje rosyjskiej i ukraińskiej piosenki - od Chóru Aleksandrowa po Okean Elzy, od 5\'nizzy po t.A.T.u.'},
        //{id: 80,  name: 'RMF Kolędy',           key: 'rmfkoledy',           slug: 'rmf-koledy',                 stream: 'koledy',           slogan: 'Gwiazdy na gwiazdkę. Stacja z najpiękniejszymi kolędami w wykonaniu Anny Marii Jopek, Golec uOkiestry, Krzysztofa Krawczyka i wielu innych. Hej kolęda, kolęda!'},
        {id: 30,  name: 'RMF Lady Pank',        key: 'rmfladypank',         slug: 'rmf-lady-pank',              stream: 'ladypank',         slogan: 'Stacja poświęcona jednemu z najważniejszych zespołów w historii polskiego rocka. Najnowsze hity, klasyczne przeboje i muzyczne ciekawostki.'},
        {id: 14,  name: 'RMF Love',             key: 'rmflove',             slug: 'rmf-love',                   stream: 'love',             slogan: 'Najpiękniejsze piosenki o miłości do słuchania nie tylko we dwoje. Phil Collins, Celine Dion, Rod Stewart oraz polskie ballady Perfectu czy De Mono. Ciepła muzyka na długie jesienno-zimowe wieczory.'},
        {id: 22,  name: 'RMF Maxxx Hop-Bęc',    key: 'rmfhopbec',           slug: 'rmf-hopbec',                 stream: 'hopbec',           slogan: 'Lista przebojów stacji RMF MAXXX teraz całą dobę w internecie. Przemek Grabowski prezentuje największe hity i ciekawe nowości.'},
        {id: 106, name: 'RMF Hop Bęc Old School',key:'rmfhopbecoldschool',  slug: 'rmf-hopbec-old-school',      stream: 'hopbecoldschool',  slogan: 'Na tej liście przebojów wychowało się niejedno pokolenie słuchaczy. Lata przeminęły, a przeboje pozostały. Lista niezapomnianych hitów ułożonych zgodnie z muzyczną starą szkołą.'},
        {id: 104, name: 'RMF Maxxx Ibiza',      key: 'rmfmaxxxibiza',       slug: 'rmf-ibiza',                  stream: 'ibiza',            slogan: 'Najlepsze sety wprost z najlepszych klubów Ibizy - 24 godziny na dobę, 7 dni w tygodniu. Podłącz się i poczuj klimat białej wyspy na własnej skórze.'},
        {id: 73,  name: 'RMF Michael Jackson',  key: 'rmfmichaeljackson',   slug: 'rmf-jackson',                stream: 'jackson',          slogan: 'Absolutny król popu, twórca niezapomnianych hitów, znakomity tancerz, jedna z największych gwiazd show-biznesu w historii. Michael Jackson odszedł 25 czerwca 2009 roku pozostawiając po sobie swoją muzykę.'},
        {id: 58,  name: 'RMF MJ',               key: 'rmfmj',               slug: 'rmf-mj',                     stream: 'mj',               slogan: 'Wybrałem trochę nagrań z moich ulubionych płyt, które mam w domu na półce. No i wyszło z tego radio, które zawsze chciałem mieć - mam nadzieję, że znajdziecie chwilę by go posłuchać. Zapraszam, Marcin Jędrych.'},
        {id: 33,  name: 'RMF Muzyka Filmowa',   key: 'rmffilmowa',          slug: 'rmf-muzyka-filmowa',         stream: 'filmowa',          slogan: 'Stacja z najpiękniejszymi muzycznymi tematami z filmów. Wyjątkowe obrazy budowane przez wyjątkowe dźwięki.'},
        {id: 86,  name: 'RMF Muzyka Klasyczna', key: 'rmfmuzykaklasyczna',  slug: 'rmf-muzyka-klasyczna',       stream: 'klasyczna',        slogan: 'Witaj w Filharmonii Miasta Muzyki. W repertuarze tylko największe arcydzieła muzyki klasycznej od koncertów Bacha, przez walce Straussa, opery Pucinniego po symfonie Beethovena. Rozsiądź się wygodnie i posłuchaj jak nasza orkiestra gra dla Ciebie.'},
        {id: 57,  name: 'RMF Muzzo',            key: 'rmfmuzzo',            slug: 'rmf-muzzo',                  stream: 'muzzo',            slogan: 'Najlepsza alternatywa dla list przebojów, jedyna stacja dla początkujących twórców muzyki. Posłuchaj niezależnych artystów, zostań świadkiem narodzin gwiazd.'},
        {id: 111, name: 'RMF Niezapomniane Melodie',key: 'rmfniezapomnianemelodie',slug: 'rmf-niezapomniane-melodie',stream: 'niezapomnianemelodie',slogan: 'Najsłynniejsze kompozycje wszech czasów, teraz w jednym miejscu. The Beatles, Leonard Cohen, ABBA, Bee Gees, Anna Jantar, Stevie Wonder. Tylko najwięksi, tylko w największych przebojach. Niezapomniana zabawa, niezapomniana muzyka. Te melodie powinien znać każdy!'},
        {id: 55,  name: 'RMF Nippon',           key: 'rmfnippon',           slug: 'rmf-nippon',                 stream: 'nippon',           slogan: 'Orientalny świat japońskiej muzyki - przeboje z Kraju Kwitnącej Wiśni wkraczają na europejski rynek! W tajniki azjatyckiego grania wprowadzą Was: Miyavi, Gackt, the Gazette, Dir en Grey, L\'arc en Ciel i Ayumi Hamasaki.'},
        {id: 93,  name: 'RMF Nostalgia',        key: 'rmfnostalgia',        slug: 'rmf-nostalgia',              stream: 'nostalgia',        slogan: 'Marzysz o chwili wytchnienia i refleksji? RMF Nostalgia to miejsce idealne dla Ciebie. Zadumaj się w towarzystwie łagodnych przebojów Bruce\'a Springsteena, Bryana Adamsa, Annie Lennox, Edyty Bartosiewicz, Katie Melua i wielu innych. Ta stacja to oaza spokoju i odprężenia.'},
        {id: 74,  name: 'RMF Pacuda Country',   key: 'rmfcountry',          slug: 'rmf-country',                stream: 'country',          slogan: 'Witajcie w krainie melodyjnych piosenek o życiu. Ciekawe głosy, perfekcyjne gitary, skrzypki, mandoliny... Od Johnny Casha przez Gartha Brooksa po Rascal Flatts. Od western swingu po country rock. Zaprasza Korneliusz Pacuda - Honorowy Obywatel Stanu Tennessee.'},
        {id: 23,  name: 'RMF Party',            key: 'rmfparty',            slug: 'rmf-party',                  stream: 'party',            slogan: 'Wspaniała zabawa przy największych tanecznych hitach ostatnich 20 lat. Najlepszą muzykę na imprezę grają dla Was m.in. DJ Bobo, Madonna, Ace of Base, Vengaboys i Dr. Alban.'},
        {id: 65,  name: 'RMF Piosenka Literacka',key:'rmfpiosenkaliteracka',slug: 'rmf-piosenka-literacka',     stream: 'literacka',        slogan: 'Witaj w krainie muzycznych pejzaży. Spotkaj się z muzyką Starego Dobrego Małżeństwa, Wolnej Grupy Bukowina i tekstami Agnieszki Osieckiej. RMF Piosenka Literacka - daj się zwieść na cudne manowce!'},
        {id: 36,  name: 'RMF Polski Rock',      key: 'rmfpolskirock',       slug: 'rmf-polski-rock',            stream: 'polskirock',       slogan: 'Rock znad Wisły w najlepszym wydaniu. Klasyki w wykonaniu m.in. Kultu, Perfectu, Republiki, T.Love i Hey\'a oraz wszystko, co ciekawe wśród młodych artystów polskiej sceny, m.in. Coma, czy Happysad.'},
        {id: 110, name: 'RMF Polskie Disco',    key: 'rmfpolskiedisco',     slug: 'rmf-polskie-disco',          stream: 'polskiedisco',     slogan: 'Disco ponad wszystko. To radio to nieustająca impreza, oczywiście po polsku. Największe hity sprzed lat i przeboje ostatnich miesięcy. Bierz co chcesz, nawet białego misia, bądź szalony i baw się do upadłego. RMF Polskie Disco - dobre, bo polskie.'},
        {id: 9,   name: 'RMF Polskie Przeboje', key: 'rmfpprzeboje',        slug: 'rmf-polskie-przeboje',       stream: 'pprzeboje',        slogan: 'Gramy tylko po polsku! Najnowsze przeboje i klasyka polskiej piosenki. Kasia Kowalska, Ania, Wilki, Perfect, Lady Pank i inne polskie gwiazdy.'},
        {id: 8,   name: 'RMF Poplista',         key: 'rmfpoplista',         slug: 'rmf-poplista',               stream: 'poplista',         slogan: 'Muzyka pop w najlepszym wydaniu. Największe przeboje "Poplisty" i topowe nowości.'},
        {id: 105, name: 'RMF Poplista 10 Lat',  key: 'rmfpoplista10lat',    slug: 'rmf-poplista-10-lat',        stream: 'poplista10lat',    slogan: 'Muzyka pop w najlepszym wydaniu. Największe przeboje "Poplisty" i topowe nowości prezentuje Darek Maciborek. To, co w muzyce POPularanej słuchacze POPierają najchętniej.'},
        {id: 59,  name: 'RMF POP & Colors',     key: 'rmfpnc',              slug: 'rmf-pop-and-colors',         stream: 'popcolors',        slogan: 'Oto nagrania, które zostaną ze mną na zawsze, moje osobiste kolory, którymi staram się namalować radio. Życzę miłego "oglądania" Waszych nowych odkryć i niezapomnianych chwil. Zapraszam, Darek Maciborek.'},
        {id: 38,  name: 'RMF PRL',              key: 'rmfprl',              slug: 'rmf-prl',                    stream: 'prl',              slogan: 'Czas na powrót do dawnych lat, bez cienia propagandy! Poczuj klimat dawnych prywatek, odwiedź kafejkę przy molo, przejedź się windą do nieba! Przypomnij sobie muzyczny świat w stylu PRL-u!'},
        //{id: 72,  name: 'RMF Przebój Lata',     key: 'rmfplata',            slug: 'rmf-przeboj-lata',           stream: 'przebojlata',      slogan: 'Najgorętsza stacja w mieście muzyki. Piosenki, które w te wakacje będziemy nucić najczęściej. Posłuchaj, jak brzmi lato 2011.'},
        {id: 19,  name: 'RMF Przebój Roku',     key: 'rmfproku',            slug: 'rmf-przeboj-roku',           stream: 'przebojroku',      slogan: 'Te przeboje rządziły i królowały na listach przebojów w 2011 roku. Słuchaj radia RMF Przebój Roku i poznaj piosenki-kandydatki do tytułu Przeboju Roku RMF FM. '},
        {id: 83,  name: 'RMF Punk',             key: 'rmfpunk',             slug: 'rmf-punk',                   stream: 'punk',             slogan: 'Oto historia muzycznego buntu. Od punkowych praszczurów z końca lat 60., przez klasykę brytyjskiego punka i amerykańskiego hardcore\'u, aż po bohaterów Jarocina i nową falę niegrzecznego, rebelianckiego, gitarowego grania. Zresztą... pieprzyć opis stacji! Jak punk to punk! Jarek Szubrycht.'},
        {id: 61,  name: 'RMF Queen',            key: 'rmfqueen',            slug: 'rmf-queen',                  stream: 'queen',            slogan: 'Od glam rocka, przez heavy metal i operę, po funk i rock progresywny. Rozmarzone miniatury, klasyczne kompozycje i ciężkie suity. Muzyczny eklektyzm w najlepszym królewskim wydaniu. God Save the Queen!'},
        {id: 40,  name: 'RMF Reggae',           key: 'rmfreggae',           slug: 'rmf-reggae',                 stream: 'reggae',           slogan: 'Najlepsza rastastacja w mieście. W tej dzielnicy zawsze świeci trójkolorowe słońce, a ogień Jah płonie najgorętszym płomieniem. Spotkasz tu Rasta z całego świata oraz braci i siostry polskiej sceny reggae. Big up!'},
        {id: 4,   name: 'RMF R&B',              key: 'rmfrnb',              slug: 'rmf-rnb',                    stream: 'rnb',              slogan: 'Wszystko, co najlepsze i najbardziej aktualne w tzw. "czarnej muzyce". Nelly Furtado, Justin Timberlake, Beyonce, Black Eyed Peas i wielu innych! Odkrywamy dla Was muzyczną Amerykę.'},
        {id: 1,   name: 'RMF Rock',             key: 'rmfrock',             slug: 'rmf-rock',                   stream: 'rock',             slogan: 'Red Hot Chili Peppers, Green Day, Franz Ferdinand, The Killers, System of a Down i inne gwiazdy. Rock w XXI wieku! Najciekawsze trendy i muzyczne nowości. Przekonaj się na własne uszy, że ROCK żyje!'},
        {id: 84,  name: 'RMF Rock Progresywny', key: 'rmfrockprogresywny',  slug: 'rmf-rock-progresywny',       stream: 'progrock',         slogan: 'Mistyczna kraina muzyki, w której zaklęta jest magia. Baśniowe klimaty, czar, wirtuozeria. Symfoniczne kompozycje, bogate instrumentarium. Odkryj stację pełną tajemnic - miejsce gdzie rock często spotyka się z klasyką.'},
        {id: 41,  name: 'RMF Rumor',            key: 'rmfrumor',            slug: 'rmf-rumor',                  stream: 'rumor',            slogan: 'To nie jest kolejna przyjemna stacja. Będzie mrocznie, ciężko i chropawo. Jeżeli się nie boisz, oddaj się w troskliwe ręce ponurych fachowców od dźwiękowych tortur.'},
        {id: 107, name: 'RMF Sade',             key: 'rmfsade',             slug: 'rmf-sade',                   stream: 'sade',             slogan: 'Właścicielka jednego z najsłynniejszych głosów w historii muzyki, autorka takich przebojów jak „Smooth Operator”, „King Of Sorrow” czy „By Your Side”. Wraz ze swoim zespołem już kilkadziesiąt lat kusi nas swoimi delikatnymi i hipnotyzującymi melodiami.'},
        {id: 10,  name: 'RMF Słoneczne Przeboje',key:'rmfsprzeboje',        slug: 'rmf-sloneczne-przeboje',     stream: 'sloneczneprzeboje',slogan: 'Największe wakacyjne przeboje ostatnich 30 lat i aktualne hity. Królowie ery disco: Afric Simone, ABBA i Boney M, a także współczesne gwiazdy: Black Eyed Peas, Nelly Furtado czy Beyonce!'},
        {id: 16,  name: 'RMF Smooth Jazz',      key: 'rmfsmjazz',           slug: 'rmf-smooth-jazz',            stream: 'smoothjazz',       slogan: 'Wyjątkowy nastrój, dobry smak i delikatne piękno: muzyka smooth jazzowa w najlepszym wydaniu. Nowe gwiazdy - Norah Jones i Chris Botti - oraz klasycy, jak Frank Sinatra czy Sarah Vaughan.'},
        {id: 79,  name: 'RMF Styl',             key: 'rmfstyl',             slug: 'rmf-styl',                   stream: 'styl',             slogan: 'Ta stacja odkrywa wyjątkowy świat kobiet. Wprowadzają w niego zmysłowy głos Barry\'ego White, delikatne dźwięki Simply Red i namiętne nuty Prince\'a.'},
        {id: 49,  name: 'RMF Szanty',           key: 'rmfszanty',           slug: 'rmf-szanty',                 stream: 'szanty',           slogan: 'Ahoj żeglarze oraz sympatycy pieśni i piosenek morskich! Ruszajcie z nami w rejs w do portów Waszych marzeń - płyńmy tam gdzie Kuba, Nowa Szkocja lub... Sztynort!'},
        //{id: 17,  name: 'RMF Święta',           key: 'rmfswieta',           slug: 'rmf-swieta',                 stream: 'swieta',           slogan: 'Stacja z najpopularniejszymi piosenkami świątecznymi. "Last Christmas", "All I Want For Christmas", "Mistletoe and Wine", "Happy Xmas (War is Over)" i wiele innych utworów, w których zaklęta jest magia Świąt.'},
        {id: 20,  name: 'RMF Wasza Muzyka',     key: 'rmfwmuzyka',          slug: 'rmf-wasza-muzyka',           stream: 'waszamuzyka',      slogan: 'Popularna audycja RMF FM teraz w internecie. Muzyczne dedykacje wybrane przez słuchaczy i jedyna w swoim rodzaju atmosfera. Zaprasza Tomasz Brhel.'},
        {id: 87,  name: 'RMF World Music',      key: 'rmfworldmusic',       slug: 'rmf-world-music',            stream: 'worldmusic',       slogan: 'Muzyczny pępek świata. Afrykańska energia, kubańska zmysłowość, brazylijska pasja i bałkańska żywiołowość. Tu usłyszysz muzykę Wschodu i Zachodu, Północy i Południa. Największe hity Muzyki Świata oraz utwory spoza list przebojów. Kompozycje znane i nowości etno, jeszcze niedostępne w Polsce. Zasłuchasz się! Jadwiga Polus, zapraszam.'},
        {id: 52,  name: 'RMF Ziom',             key: 'rmfziom',             slug: 'rmf-ziom',                   stream: 'ziom',             slogan: 'Radio dla ziomali z kwadratu. Sute bity - tylko polski hip-hop od hard-core\'u po lajtowy flow. Składy z legalu i nielegalu. '}
    ],
    showFakty: [1, 2, 9, 15],
    
    stationsEN: {
        28: 'RMF Alternative',
        33: 'RMF Film Music',
        86: 'RMF Classical Music',
        93: 'RMF Nostalgy',
        65: 'RMF Sung Poetry',
        36: 'RMF Polish Rock',
        9:  'RMF Polish Hits',
        72: 'RMF Summer Hit',
        92: 'RMF Year Hit',
        84: 'RMF Progressive Rock',
        10: 'RMF Sunny Hits',
        16: 'RMF Style',
        49: 'RMF Shanties',
        20: 'RMF Your Music',
        52: 'RMF Homie'
    },
    
    checkNewVersion: function(){
        try
        {
            var $req = new XMLHttpRequest();
            
            $req.onreadystatechange = function(){
                if($req.readyState == 4 && $req.status == 200)
                {
                    if($req.responseText == 'new')
                    {
                        widget.showNotification(I18N._('new_version_available'), function(){
                            widget.openURL('http://widgets.opera.com/widget/7354/');
                        });
                    }
                }
                else if($req.readyState == 4)
                {
                    opera.postError('0x11 XHR Version Check: '+$req.status+' '+$req.statusText);
                }
            }
            
            $req.open("GET", 'http://service.jedrzejewski.info/widgets/rmfrds/check.php?v='+Rds.version+'&u='+widget.identifier+'&_rand='+Math.random(), true);
            $req.send(null);
        }
        catch(exception)
        {
            opera.postError('0x10 XHR Version Check EXCEPTION: '+exception);
        }
    },
    
    detectPlugin: function(name, mime, filename){
        state = false;
        
        if(navigator.plugins && navigator.plugins.length > 0)
        {
            for(var plugin in navigator.plugins)
            {
                if(navigator.plugins[plugin].name.indexOf(name) >= 0)
                {
                    if(!filename || navigator.plugins[plugin].filename == filename)
                    {
                        state = true;
                        break;
                    }
                }
            }
        }
        
        if(!state)
        {
            return false;
        }
        
        state2 = false;
        for(var type in navigator.mimeTypes)
        {
            if(navigator.mimeTypes[type].type == mime)
            {
                state2 = true;
            }
        }
        
        return state && state2;
    }
});