/*
    --------------------------------------------------------------------
                             RMF RDS Widget
                Copyright (c) 2007-2012 Jacek Jędrzejewski
                    http://www.jacek.jedrzejewski.name/
                          All rights reserved.
    --------------------------------------------------------------------

    This file is part of RMF RDS Widget.
*/

window.addEventListener('load', function(ev){
    // check debug version
    if(Rds.version.indexOf('dev') > 0)
    {
        Rds.debug = true;
    }
    
    $('#about div p strong span.version')[0].innerText = Rds.version;
    
    var pref_locale = widget.preferenceForKey('pref_locale');
    if(pref_locale.length == 0)
    {
        widget.setPreferenceForKey('pl', 'pref_locale');
        pref_locale = 'pl';
    }
    
    I18N.setLocale(pref_locale);
    
    var lang_select = $('#sett_lang')[0];
    var i;
    for(i = 0; i < lang_select.options.length; i++)
    {
        if(lang_select.options[i].value == pref_locale)
        {
            break;
        }
    }
    lang_select.selectedIndex = i;
    
    I18N.translateDOM();
    
    var pref_animations = widget.preferenceForKey('pref_animations');
    if(pref_animations.length == 0)
    {
        widget.setPreferenceForKey('yes', 'pref_animations');
        pref_animations = 'yes';
    }
    
    if(pref_animations == 'yes')
    {
        $('#settings input[name="anim"]')[0].checked = true;
    }
    else
    {
        Rds.animations = false;
    }
    
    var pref_wmp_player = widget.preferenceForKey('pref_wmp_player');
    if(pref_wmp_player.length == 0)
    {
        widget.setPreferenceForKey('no', 'pref_wmp_player');
        pref_wmp_player = 'no';
    }
    
    if(pref_wmp_player == 'yes')
    {
        $('#settings input[name="wmp"]')[0].checked = true;
    }
    
    var pref_always_scrobble = widget.preferenceForKey('pref_always_scrobble');
    if(pref_always_scrobble.length == 0)
    {
        widget.setPreferenceForKey('no', 'pref_always_scrobble');
        pref_always_scrobble = 'no';
    }
    
    if(pref_always_scrobble == 'yes')
    {
        $('#settings input[name="always_scrobble"]')[0].checked = true;
        Rds.always_scrobble = true;
    }
    
    var sett_as_sk = widget.preferenceForKey('as_sk');
    if(sett_as_sk.length == 0)
    {
        widget.setPreferenceForKey('', 'as_sk');
        sett_as_sk = '';
    }
    AS.sk = sett_as_sk;
    var $as_state = $('#settings .scrobbling p.status span.state')[0];
    
    AS.disable_callback = function(){
        var $as_state = $('#settings .scrobbling p.status span.state')[0];
        
        $as_state.dataset.i18n = 'as_status_inactive';
        $as_state.removeClass('active');
        $as_state.addClass('inactive');
        $as_state.innerHTML = I18N._('as_status_inactive');
        
        $('#settings .scrobbling div.ui_inactive')[0].style.display = 'block';
        $('#settings .scrobbling div.ui_active')[0].style.display = 'none';
        
        $('#settings .scrobbling div.ui_inactive span.auth_access')[0].style.display = 'inline-block';
        
        $('#settings .scrobbling span.as_disable')[0].style.display = 'none';
    };
    
    if(sett_as_sk.length)
    {
        AS.active = true;
        
        $as_state.dataset.i18n = 'as_status_active';
        $as_state.removeClass('inactive');
        $as_state.addClass('active');
        $as_state.innerHTML = I18N._('as_status_active');
        
        $('#settings .scrobbling div.ui_active')[0].style.display = 'block';
        $('#settings .scrobbling span.as_disable')[0].style.display = 'inline';
        
        var as_username = widget.preferenceForKey('as_username');
        AS.username = as_username;
        
        $('#settings .scrobbling div.ui_active .username')[0].innerHTML = escape(AS.username);
    }
    else
    {
        AS.active = false;
        
        $as_state.dataset.i18n = 'as_status_inactive';
        $as_state.removeClass('active');
        $as_state.addClass('inactive');
        $as_state.innerHTML = I18N._('as_status_inactive');
        
        $('#settings .scrobbling div.ui_inactive')[0].style.display = 'block';
        $('#settings .scrobbling span.as_disable')[0].style.display = 'none';
        
        var as_token = widget.preferenceForKey('as_token');
        
        if(as_token.length)
        {
            AS.token = as_token;
            $('#settings .scrobbling div.ui_inactive span.auth_access')[0].style.display = 'none';
            $('#settings .scrobbling div.ui_inactive span.auth_continue')[0].style.display = 'inline-block';
        }
    }
    
    $('#settings .scrobbling div.ui_inactive span.auth_access')[0].addEventListener('click', function(){
        AS.getToken();
        
        this.style.display = 'none';
        $('#settings .scrobbling div.ui_inactive span.auth_continue')[0].style.display = 'inline-block';
        
        $as_state.dataset.i18n = 'as_status_awiting';
        $as_state.removeClass('inactive');
        $as_state.addClass('awaiting');
        $as_state.innerHTML = I18N._('as_status_awaiting');
    }, false);
    
    $('#settings .scrobbling div.ui_inactive span.auth_continue')[0].addEventListener('click', function(){
        AS.getSessionKey(function(){
            $('#settings .scrobbling div.ui_inactive span.auth_continue')[0].style.display = 'none';
            
            if(AS.call_response == true)
            {
                AS.active = true;
                
                $('#settings .scrobbling div.ui_inactive')[0].style.display = 'none';
                $('#settings .scrobbling div.ui_active')[0].style.display = 'block';
                
                $as_state.dataset.i18n = 'as_status_active';
                $as_state.removeClass('awaiting');
                $as_state.addClass('active');
                $as_state.innerHTML = I18N._('as_status_active');
                
                $('#settings .scrobbling div.ui_active .username')[0].innerHTML = escape(AS.username);
                
                $('#settings .scrobbling span.as_disable')[0].style.display = 'inline';
            }
            else
            {
                $('#settings .scrobbling div.ui_inactive span.auth_access')[0].style.display = 'inline-block';
                
                $as_state.dataset.i18n = 'as_status_error';
                $as_state.removeClass('awaiting');
                $as_state.addClass('inactive');
                $as_state.innerHTML = I18N._('as_status_error');
            }
        });
    }, false);
    
    $('#settings .scrobbling div.ui_active .username')[0].addEventListener('click', function(){
        widget.openURL('http://www.last.fm/user/'+escape(AS.username));
        
        return false;
    }, false);
    
    $('#settings .scrobbling span.as_disable > span')[0].addEventListener('click', function(){
        AS.disable();
        
        AS.disable_callback();
    }, false);
    
    var user_favorites = widget.preferenceForKey('user_favorites');
    if(user_favorites.length == 0)
    {
        widget.setPreferenceForKey('5,7,6', 'user_favorites');
        user_favorites = '5,7,6';
    }
    
    Rds.userFavorites = user_favorites.split(',');
    for(var i in Rds.userFavorites)
    {
        Rds.userFavorites[i] = parseInt(Rds.userFavorites[i]);
    }
    
    for(var i in Rds.stations)
    {
        id = Rds.stations[i].id;
        Rds.stationListOrder.push(Rds.stations[i].id);
    }
    
    var stationList = $('#stations ul.all')[0];
    var stationListFav = $('#stations ul.favorites')[0];
    var titleEnAttribute = '';
    
    for(var i in Rds.stations)
    {
        id = Rds.stations[i].id;
        Rds.stationList[id] = Rds.stations[i];
        
        var li = document.createElement('li');
        
        titleEnAttribute = '';
        if(typeof Rds.stationsEN[parseInt(id)] != 'undefined')
        {
            titleEnAttribute = 'data-title-en="'+Rds.stationsEN[id]+'" ';
        }
        
        li.className = 'station';
        li.id = 'st'+id;
        li.innerHTML = '<small></small> <span data-id="'+id+'"><strong '+titleEnAttribute+'data-title="'+html_entity_encode(Rds.stations[i].slogan)+'">'+html_entity_encode(Rds.stations[i].name)+'</strong></span> <em></em>';  
        
        if(pref_locale == 'pl')
        {
            $('strong', li)[0].setAttribute('title', $('strong', li)[0].dataset.title);
        }
        else
        {
            if(typeof $('strong', li)[0].dataset.titleEn != 'undefined')
            {
                $('strong', li)[0].setAttribute('title', $('strong', li)[0].dataset.titleEn);
            }
            else
            {
                $('strong', li)[0].setAttribute('title', '');
            }
        }
        
        li.addEventListener('mouseover', mover = function(ev, go){
            if(go)
            {
                var target = go;
            }
            else
            {
                var target = this;
            }
            if(Rds.stationScroll.movingBar)
            {
                Rds.stationScroll.movingBarReleaseCallback = function(){ mover(false, target); };
                return false;
            }
            if(Rds.stationScroll.scrollingActive)
            {
                return false;
            }
            
            target.addClass('hover');
            
            id = $('span', target)[0].dataset.id;
            if(id == Rds.currentStation)
            {
                return true;
            }
            
            $('#song')[0].style.display = 'none';
            $('#song_station')[0].style.display = 'block';
            Rds.updateStationNowPlaying(id);
            
            info = Rds.stationList[id];
            $('.station #stationimg')[0].setAttribute('src', 'images/logos/'+info.key+'.png');
            $('#nowplaying .nowplaying strong')[0].innerText = info.name;
            $('#nowplaying .nowplaying span')[0].innerText = info.name;
            
        }, false);
        li.addEventListener('mouseout', function(){
            if(Rds.stationScroll.movingBar && !this.hasClass('active'))
            {
                Rds.stationScroll.movingBarReleaseCallback = false;
                return false;
            }
            
            this.removeClass('hover');
            
            id = $('span', this)[0].dataset.id;
            if(id == Rds.currentStation)
            {
                return false;
            }
            
            $('#song_station')[0].style.display = 'none';
            $('#song')[0].style.display = 'block';
            $('.station #stationimg')[0].setAttribute('src', 'images/logos/'+Rds.info.key+'.png');
            $('#nowplaying .nowplaying strong')[0].innerText = Rds.info.name;
            $('#nowplaying .nowplaying span')[0].innerText = Rds.info.name;
            
        }, false);
        
        if(in_array(id, Rds.userFavorites))
        {
            stationListFav.appendChild(li);
        }
        else
        {
            stationList.appendChild(li);
        }
        
    }
    
    /* FAVORITES */
    var f_stationList = $('#stations ul li');
    for(var i in f_stationList)
    {
        $('small', f_stationList[i])[0].addEventListener('click', function(ev){
            if(ev.button != 0) return false;
            var isFavorite = this.parentNode.parentNode.hasClass('favorites');
            
            var position = 0;
            var id = parseInt($('span', this.parentNode)[0].dataset.id);
            for(var i in Rds.stationListOrder)
            {
                if(Rds.stationListOrder[i] == id)
                {
                    position = i;
                    break;
                }
            }
            var hold = false;
            
            Rds.tempAllStationList = [];
            Rds.tempFavouriteStationList = [];
            
            var worker = function(className, tempArrayName, flag){
                var stations = $('#stations ul.'+className+' li');
                var stationUl = $('#stations ul.'+className)[0];
                for(var i in stations)
                {
                    id2 = parseInt($('span', stations[i])[0].dataset.id);
                    
                    stations[i].removeClass('hover');
                    
                    if(id == id2 && !flag)
                    {
                        hold = stations[i];
                        stationUl.removeChild(stations[i]);
                    }
                    else
                    {
                        if(flag)
                        {
                            pos = 0;
                            for(var j in Rds.stationListOrder)
                            {
                                if(Rds.stationListOrder[j] == id2)
                                {
                                    pos = j;
                                    break;
                                }
                            }
                            if(parseInt(pos) > parseInt(position) && hold !== false)
                            {
                                Rds[tempArrayName].push(hold);
                                hold = false;
                            }
                            
                            if(hold === false)
                            {
                                Rds[tempArrayName].push(stations[i]);
                                stationUl.removeChild(stations[i]);
                            }
                        }
                    }
                }
                
                if(flag && hold !== false)
                {
                    Rds[tempArrayName].push(hold);
                }
            }
            
            if(!isFavorite)
            {
                worker('all', 'tempAllStationList', isFavorite);
                worker('favorites', 'tempFavouriteStationList', !isFavorite);
                
                Rds.userFavorites.push(id);
                
                widget.setPreferenceForKey(Rds.userFavorites.join(','), 'user_favorites');
                
                var stationUl = $('#stations ul.favorites')[0];
                for(var i in Rds.tempFavouriteStationList)
                {
                    stationUl.appendChild(Rds.tempFavouriteStationList[i]);
                }
            }
            else
            {
                worker('favorites', 'tempFavouriteStationList', !isFavorite);
                worker('all', 'tempAllStationList', isFavorite);
                
                array_remove(Rds.userFavorites, id);
                
                widget.setPreferenceForKey(Rds.userFavorites.join(','), 'user_favorites');
                
                var stationUl = $('#stations ul.all')[0];
                for(var i in Rds.tempAllStationList)
                {
                    stationUl.appendChild(Rds.tempAllStationList[i]);
                }
            }
            
        }, false);
    }
    
    if(Rds.animations)
    {
        $('#container')[0].style.opacity = 0;
        $('#container')[0].style.visibility = 'visible';
        
        animRun = $('#container')[0].createAnimation();
        animRun.speed = 10;
        animRun.accelerationProfile = function(x){return .8;}
        
        animRun.addAnimation('opacity', 0, 1);
        animRun.onfinish = function(){  }
        animRun.run();
    }
    else
    {
        $('#container')[0].style.opacity = 1;
        $('#container')[0].style.visibility = 'visible';
    }
    
    var prefFavs = widget.preferenceForKey('favourites_1');
    widget.setPreferenceForKey('a:0:{}', 'favourites_1');
    prefFavs = 'a:0:{}';
    
    var playFakty = widget.preferenceForKey('play_fakty');
    if(playFakty.length == 0)
    {
        widget.setPreferenceForKey('no', 'play_fakty');
        playFakty = 'no';
    }
    Rds.playFakty(playFakty, false);
    
    var prefStation = widget.preferenceForKey('rds_id');
    if(prefStation.length == 0)
    {
         widget.setPreferenceForKey(5, 'rds_id');
         prefStation = 5;
    }
    Rds.changeStationInfo(prefStation);
    
    Rds.flashEnabled = Rds.detectPlugin('Shockwave Flash', 'application/x-shockwave-flash', false);
    Rds.wmpEnabled = Rds.detectPlugin('Windows Media Player', 'application/x-mplayer2', 'np-mswmp.dll');
    
    if(pref_wmp_player == 'yes' && Rds.wmpEnabled)
    {
        Rds.flashEnabled = false;
    }
    
    if(Rds.flashEnabled)
    {
        $('#handle')[0].innerHTML = '<object id="streaming" width="0" height="0"><param name="allowScriptAccess" value="always"/><param name="movie" value="player/player.swf"></object>'+$('#handle')[0].innerHTML;
    }
    else if(Rds.wmpEnabled)
    {
        $('#handle')[0].innerHTML = '<embed type="application/x-mplayer2" url="" name="streaming" width="0" height="0" style="visibility: hidden"></embed>'+$('#handle')[0].innerHTML;
    }
    
    Rds.streaming = new Player(Rds.flashEnabled, Rds.wmpEnabled);

    animNP = $('#nowplaying')[0].createAnimation();
    animNP.speed = 3;
    animNP.accelerationProfile = function(x){ return .8; }
    animBO = $('#bottom')[0].createAnimation();
    animBO.speed = 3;
    animBO.accelerationProfile = function(x){ return .8; }
    animLY = $('#lyrics')[0].createAnimation();
    animLY.speed = 3;
    animLY.accelerationProfile = function(x){ return .8; }
    
    animPanelST = $('#stationsbox')[0].createAnimation();
    animPanelST.speed = 15;
    animPanelST.accelerationProfile = function(x){ return .8; }
    animPanelPL = $('#playlist')[0].createAnimation();
    animPanelPL.speed = 15;
    animPanelPL.accelerationProfile = function(x){ return .8; }
    animPanelSE = $('#settings')[0].createAnimation();
    animPanelSE.speed = 15;
    animPanelSE.accelerationProfile = function(x){ return .8; }
    animPanelAB = $('#about')[0].createAnimation();
    animPanelAB.speed = 15;
    animPanelAB.accelerationProfile = function(x){ return .8; }
    $('#stationsbox')[0].style.opacity = 0;
    $('#settings')[0].style.opacity = 0;
    $('#about')[0].style.opacity = 0;
    $('#playlist')[0].style.opacity = 1;

    var play_music_volume = widget.preferenceForKey('play_music_volume');
    if(play_music_volume.length == 0)
    {
        widget.setPreferenceForKey(40, 'play_music_volume');
        play_music_volume = 40;
    }
    
    var play_music = widget.preferenceForKey('play_music');
    if(play_music.length == 0)
    {
        widget.setPreferenceForKey('no', 'play_music');
        play_music = 'no';
    }
    
    $('#controls span.playback_play')[0].style.display = 'block';
    $('#controls span.playback_play')[0].style.opacity = 0.5;
    
    if(Rds.streaming.enabled)
    {
        volume = parseInt(play_music_volume);
        Rds.musicVolume(volume, true, true);
        
        Rds.streaming.initialize(Rds.getStationStreamURL(), volume, play_music != 'no', function(){
            $('#controls span.playback_play')[0].style.opacity = 1.0;
            if(play_music == 'no')
            {
                Rds.musicStop();
            }
            else
            {
                Rds.musicPlay(true);
            }
        });
    }
    else
    {
        $('#bSpeaker')[0].style.opacity = 0.5;
    }
    
    $('#playlist')[0].style.display = 'block';
    $('#about')[0].style.display = 'none';
    $('#stationsbox')[0].style.display = 'none';
    
    
    //$('#bPlaylist')[0].style.display = 'none';

    var show_nowplaying = widget.preferenceForKey('rds_nowplaying'); 
    var show_playlist = widget.preferenceForKey('rds_playlist');
    if(show_nowplaying == 'hide')
    {
        $('#nowplaying')[0].style.top = '160px';
        Rds.nowplaying = 'hide';
    }
    else
    {
        $('#nowplaying')[0].style.top = '0';
    }
    
    if(show_playlist == 'hide')
    {
        $('#bottom')[0].style.top = '-235px';
        Rds.bottom = 'hide';
        $('#bottomcnt')[0].style.display = 'none';
    }
    else
    {
        $('#bottom')[0].style.top = '-70px';
    }
    
    var spans = $('#song .play li span');
    var i;
    for(i in spans)
    {
        spans[i].addEventListener('mouseup', function(ev){
            format = this.innerText.toLowerCase();
            if(typeof(Rds.info.key) != "undefined" && Rds.info.key.length > 0)
            {
                /*var f = '';
                if(Rds.fakty == 'yes' && in_array(Rds.currentStation, Rds.showFakty))
                {
                    f = '-facts';
                }*/
                widget.openURL('http://files.kusmierz.be/rmf/'+Rds.info.stream+'.'+format);
            }
        }, false);
    }
    
    // dirty workaround for being unable to open lang menu
    lang_select.addEventListener('click', function(ev){
        this.focus();
    }, false);
    
    lang_select.addEventListener('change', function(ev){
        if(pref_locale == this.options.item(this.selectedIndex).value)
        {
            return true;
        }
        
        pref_locale = this.options.item(this.selectedIndex).value;
        widget.setPreferenceForKey(pref_locale, 'pref_locale');
        
        I18N.setLocale(pref_locale);
        
        I18N.translateDOM();
        
        var $strongs = $('#stations li strong');
        var titleAttribute = '';
        
        for(var i = 0; i < $strongs.length; i++)
        {
            titleAttribute = '';
            
            if(pref_locale == 'pl')
            {
                titleAttribute = $strongs[i].dataset.title;
            }
            else if(typeof $strongs[i].dataset.titleEn != 'undefined')
            {
                titleAttribute = $strongs[i].dataset.titleEn;
            }
            
            $strongs[i].setAttribute('title', titleAttribute);
        }
    }, false);
    
    $('#settings input[name="anim"]')[0].addEventListener('change', function(ev){
        if(this.checked)
        {
            widget.setPreferenceForKey('yes', 'pref_animations');
            pref_animations = 'yes';
            Rds.animations = true;
        }
        else
        {
            widget.setPreferenceForKey('no', 'pref_animations');
            pref_animations = 'no';
            Rds.animations = false;
        }
    }, false);    
    
    $('#settings input[name="wmp"]')[0].addEventListener('change', function(ev){
        if(this.checked)
        {
            widget.setPreferenceForKey('yes', 'pref_wmp_player');
            pref_wmp_player = 'yes';
        }
        else
        {
            widget.setPreferenceForKey('no', 'pref_wmp_player');
            pref_wmp_player = 'no';
        }
    }, false);
    
    $('#settings input[name="always_scrobble"]')[0].addEventListener('change', function(ev){
        if(this.checked)
        {
            widget.setPreferenceForKey('yes', 'pref_always_scrobble');
            pref_always_scrobble = 'yes';
            Rds.always_scrobble = true;
            
            if(Rds.song.author.length > 0 && Rds.song.title.length > 0 && Rds.musicState != 'play')
            {
                AS.setSong(Rds.song.title, Rds.song.author, Rds.song.recordTitle);
            }
        }
        else
        {
            widget.setPreferenceForKey('no', 'pref_always_scrobble');
            pref_always_scrobble = 'no';
            Rds.always_scrobble = false;
            
            if(Rds.musicState != 'play')
            {
                AS.clearSong();
            }
        }
    }, false);
    
    var currentStationPosition = 0;
    
    var stations = $('#stations li');
    var i;
    for(i in stations)
    {
        var span = $('span', stations[i])[0];

        stations[i].onselectstart = function(){ return false; } 
        stations[i].onmouseup = function(){ return false; }
        stations[i].onmousedown = function(){ return false; } 
            
        var id = parseInt(span.dataset.id);
        
        if(id == Rds.currentStation)
        {
            currentStationPosition = i;
        }
        
        span.addEventListener('mouseup', function(ev){
            Rds.changeStation(parseInt(this.dataset.id));
            return false;
        }, false);
        
        span.addEventListener('dblclick', function(ev){
            Rds.openPlayer(parseInt(this.dataset.id));
            return false;
        }, false);
    }
    
    Rds.checkNewVersion();
    
    Rds.update();
    Rds.updateStations();
    
    Rds.stationList(parseInt(currentStationPosition));
    
    var displayLyrics = widget.preferenceForKey('display_lyrics');
    if(displayLyrics.length == 0)
    {
        widget.setPreferenceForKey('no', 'display_lyrics');
        displayLyrics = 'no';
    }
    if(displayLyrics == 'yes' && show_playlist != 'hide')
    {
        widget.setPreferenceForKey('no', 'display_lyrics');
        displayLyrics = 'no';
    }
    if(displayLyrics == 'yes')
    {
        $('#lyricscnt')[0].style.display = 'block';
        $('#lyrics')[0].style.top = '0';
        Rds.lyrics = 'show';
        Rds.bottom = 'lyrics';
        Rds.initializeLyricsScroll();
    }
    else
    {
        $('#lyricscnt')[0].style.display = 'none';
        $('#lyrics')[0].style.top = '-384px';
    }
    
    var musicWheel = function(ev){
        if(!Rds.streaming.enabled) return false;
        
        ev.preventDefault();
        ev.stopPropagation();
        delta = ev.wheelDelta / 100;
        
        if(delta)
        {
            factor = Math.floor(Math.abs(delta));
            volume = Rds.musicVolumeValue;
            if(delta < 0)
            {
                volume -= 3*factor;
            }
            else if(delta > 0)
            {
                volume += 3*factor;
            }
            if(volume < 0)
            {
                volume = 0;
            }
            else if(volume > 100)
            {
                volume = 100;
            }
            Rds.musicVolume(volume, true);
        }
        return false;
    };
    
    $('#bSpeaker div.speaker')[0].addEventListener('mousewheel', musicWheel, false);
    $('#bSpeaker #volumeInner')[0].addEventListener('mousewheel', musicWheel, false);
    
    // -------------------------------------------------------------------------------------
    
    var _volumeDragActive = false;
    var _volumeDragReleaseCallback = false;
    
    var animVolume = $('#volume')[0].createAnimation();
    animVolume.speed = 13;
    animVolume.accelerationProfile = function(x){ return .8; }
    $('#volume')[0].style.width = '0';
    
    function volumeHideFunction(){
        if(_volumeDragActive)
        {
            $('#volumeInner div.handle')[0].removeClass('active');
            _volumeDragActive = false;
            _volumeDrag = null;
            _lastPos = null;
            document.onmousemove = null;
        }
        
        animVolume.stop();
        
        if(Rds.animations)
        {
            animVolume.addAnimation('width', $('#volume')[0].style.width, '5px');
            animVolume.onfinish = function(){  }
            animVolume.run();
        }
        else
        {
            $('#volume')[0].style.width = '5px';
        }
    }
    
    var volumeHideTimeout = false;
    
    $('#bSpeaker div.speaker')[0].addEventListener('mouseover', function(ev){
        if(!Rds.streaming.enabled) return false;
        
        if(_volumeDragReleaseCallback !== false)
        {
            _volumeDragReleaseCallback = false;
        }
        
        clearTimeout(panelsHideTimeout);
        
        clearTimeout(volumeHideTimeout);
        
        animVolume.stop();
        
        if(Rds.animations)
        {
            animVolume.addAnimation('width', $('#volume')[0].style.width, '125px');
            animVolume.onfinish = function(){  }
            animVolume.run();
        }
        else
        {
            $('#volume')[0].style.width = '125px';
        }
    }, false);
    
    $('#volume')[0].addEventListener('mouseover', function(ev){
        if(!Rds.streaming.enabled) return false;
        
        if(_volumeDragReleaseCallback !== false)
        {
            _volumeDragReleaseCallback = false;
        }
        
        clearTimeout(volumeHideTimeout);
        
        clearTimeout(panelsHideTimeout);
    }, false);
    
    var speakerOutCallback = function(ev){
        if(!Rds.streaming.enabled) return false;
        
        if(_volumeDragActive)
        {
            _volumeDragReleaseCallback = function()
            {
                volumeHideTimeout = setTimeout(volumeHideFunction, 100);
            }
        }
        else
        {
            volumeHideTimeout = setTimeout(volumeHideFunction, 500);
        }
        
        if(panelsButtonsExpanded)
        {
            panelsOutCallback(ev);
        }
    };
    
    $('#bSpeaker div.speaker')[0].addEventListener('mouseout', speakerOutCallback, false);
    $('#volume')[0].addEventListener('mouseout', speakerOutCallback, false);
    
    // -------------------------------------------------------------------------------------
    
    var panelsHideTimeout = false;
    var panelsButtonsExpanded = false;
    
    var animPanels = $('#panels')[0].createAnimation();
    animPanels.speed = 13;
    animPanels.accelerationProfile = function(x){ return .8; }
    $('#panels')[0].style.width = '0';
    
    function buttonsHideFunction(){
        animPanels.stop();
        
        if(Rds.animations)
        {
            animPanels.addAnimation('width', $('#panels')[0].style.width, '0');
            animPanels.onfinish = function(){
                panelsButtonsExpanded = false;
            }
            animPanels.run();
        }
        else
        {
            $('#panels')[0].style.width = '0';
        }
    }
    
    $('#bPanels div.icon')[0].addEventListener('mouseover', function(ev){
        clearTimeout(panelsHideTimeout);
        
        animPanels.stop();
        
        if(Rds.animations)
        {
            animPanels.addAnimation('width', $('#panels')[0].style.width, '95px');
            animPanels.onfinish = function(){  }
            animPanels.run();
        }
        else
        {
            $('#panels')[0].style.width = '95px';
        }
        
        panelsButtonsExpanded = true;
    }, false);
    
    $('#panels')[0].addEventListener('mouseover', function(ev){
        clearTimeout(panelsHideTimeout);
    }, false);
    
    var panelsOutCallback = function(ev){
        panelsHideTimeout = setTimeout(buttonsHideFunction, 500);
    };
    
    $('#bPanels div.icon')[0].addEventListener('mouseout', panelsOutCallback, false);
    $('#panels')[0].addEventListener('mouseout', panelsOutCallback, false);
    
    // -------------------------------------------------------------------------------------
    
    var _volumeDrag = null;
    
    var _lastPos = null;
    $('#volumeInner div.handle')[0].addEventListener('mousedown', function(e){
        if(!Rds.streaming.enabled)
        {
            return false;
        }
        
        if(e.button != 0) return false;
        this.addClass('active');
        
        _volumeDragActive = true;
        
        target = this;
        
        _startX = e.clientX;
        _lastPos = _startX;
        _offsetX = extract_number(target.style.left);
        _volumeDrag = target;
        
        document.onmousemove = function(e){
            if(_volumeDrag == null)
            {
                return false;
            }
            if(_lastPos == null)
            {
                _lastPos = parseInt(_startX);
            }
            
            if(_lastPos != e.clientX)
            {
                var delta = _lastPos - e.clientX;
                var pos = _offsetX+e.clientX-_startX;
                
                var left = parseInt(target.style.left); 
                var max = 114-14;
                var stop = false;

                if((delta < 0 && pos >= left) || (delta > 0 && pos <= left))
                {
                    left -= delta;
                    
                    if(left < 0)
                    {
                        left = 0;
                    }
                    
                    if(left > max)
                    {
                        left = max;
                    }
                    
                    target.style.left = left+'px';
                    
                    ratio = Math.floor((left) * 100 / (114-14));
                    Rds.musicVolume(ratio);
                }
            }
            
            _lastPos = parseInt(e.clientX);
        };
        
        document.body.focus();
        return false;
    }, false);
    
    document.addEventListener('mouseup', function(e){
        if(_volumeDrag != null && Rds.streaming.enabled)
        {   
            $('#volumeInner div.handle')[0].removeClass('active');
            _volumeDragActive = false;
            
            if(_volumeDragReleaseCallback !== false && typeof _volumeDragReleaseCallback == 'function')
            {
                _volumeDragReleaseCallback();
            }
            
            _volumeDrag = null;
            _lastPos = null;
            document.onmousemove = null;
        }
    }, false);
    
    $('div#bSpeaker div#volumeInner div.slide')[0].addEventListener('click', function(ev){
        if(ev.button != 0) return false;
        
        var pos = ev.clientX-findPosX(this);
        
        if(pos < 7 || pos > 107)
        {
            return false;
        }
        else
        {
            volume = pos-7;
        }
        
        Rds.musicVolume(volume, true);
    }, false);
    
    animPlayFormats = $('#nowplaying .song .play ul')[0].createAnimation();
    animPlayFormats.speed = 20;
    animPlayFormats.accelerationProfile = function(x){ return .8; }
    $('#nowplaying .song .play ul')[0].style.opacity = '0';
    
    $('#nowplaying .song .play')[0].addEventListener('mouseover', function(ev){
        animPlayFormats.stop();
        $('#nowplaying .song .play ul')[0].style.display = 'block';
        
        if(Rds.animations)
        {
            animPlayFormats.addAnimation('opacity', $('#nowplaying .song .play ul')[0].style.opacity, 1);
            animPlayFormats.onfinish = function(){  }
            animPlayFormats.run();
        }
        else
        {
            $('#nowplaying .song .play ul')[0].style.opacity = 1;
        }
    }, false);
    
    $('#nowplaying .song .play')[0].addEventListener('mouseout', function(ev){
        animPlayFormats.stop();
        
        if(Rds.animations)
        {
            animPlayFormats.addAnimation('opacity', $('#nowplaying .song .play ul')[0].style.opacity, 0);
            animPlayFormats.onfinish = function()
            {
                $('#nowplaying .song .play ul')[0].style.display = 'none';
            }
            animPlayFormats.run();
        }
        else
        {
            $('#nowplaying .song .play ul')[0].style.opacity = 0;
            $('#nowplaying .song .play ul')[0].style.display = 'none';
        }
    }, false);
    
    document['onscroll'] = function(ev){
        window.scroll(0, 0);

        return false;
    }
    
    window.addEventListener('keypress', function(ev){
        var KeyID = ev.keyCode;
        switch(KeyID)
        {
            case 115: // s
            case 112: // p
            case 108: // l
            case 97: // a
            case 99: // c
            case 37: // Arrow Left
            case 39: // Arrow Right
            case 38: // Arrow Up
            case 40: // Arrow Down
                ev.preventDefault();
                ev.stopPropagation();
                
                break;
        }
        
        switch(KeyID)
        {
            case 115: // s
                Rds.showStations();
                break;
            case 112: // p
                Rds.showPlaylist();
                break;
            case 108: // l
                Rds.showLyrics();
                break;
            case 97: // a
                Rds.showAbout();
                break;
            case 99: // c
                Rds.showSettings(true);
                break;
        }
        
        if(Rds.bottomActive == 'stations')
        {
            switch(KeyID)
            {
                case 38: // Arrow Up
                    prev = null;
                    var stationList = $('#stations li');
                    for(var i in stationList)
                    {
                        var id = parseInt($('span', stationList[i])[0].dataset.id);
                        if(Rds.currentStation == id)
                        {
                            var currentStationPosition = parseInt(i);
                            break;
                        }
                        prev = stationList[i];
                    }
                    
                    if(prev == null)
                    {
                        return false;
                    }
                    
                    var prevPos = currentStationPosition-2;
                    if(prevPos < 0)
                    {
                        prevPos = 0;
                    }
                    
                    if(0-prevPos*15 > Rds.stationScroll._contentTop)
                    {
                        Rds.stationScroll.scrollTo(0-prevPos*15);
                    }
                    
                    if(Rds.stationScroll._contentTop-12*15 > 0-currentStationPosition*15)
                    {
                        Rds.stationScroll.scrollTo(0-prevPos*15);
                    }
                    
                    var span = $('span', prev)[0];
                    if(span == null)
                    {
                        return false;
                    }
                    
                    var id = parseInt(span.dataset.id);
                    
                    Rds.changeStation(id);
                    
                    break;
                case 40: // Arrow Down
                    next = null;
                    flag = false;
                    var stationList = $('#stations li');
                    for(var i in stationList)
                    {
                        if(flag)
                        {
                            next = stationList[i];
                            break;
                        }
                        var id2 = parseInt($('span', stationList[i])[0].dataset.id);
                        if(Rds.currentStation == id2)
                        {
                            var id = id2;
                            var currentStationPosition = parseInt(i);
                            flag = true;
                        }
                    }
                    
                    if(next == null)
                    {
                        return false;
                    }
                    
                    var nextPos = currentStationPosition-9;
                    if(nextPos > stations.length-12)
                    {
                        nextPos = stations.length-12;
                    }  
                    
                    if(0-nextPos*15 < Rds.stationScroll._contentTop)
                    {
                        Rds.stationScroll.scrollTo(0-nextPos*15);
                    }
                    else if(Rds.stationScroll._contentTop < 0-currentStationPosition*15)
                    {
                        Rds.stationScroll.scrollTo(0-nextPos*15);
                    }
                    
                    var span = $('span', next)[0];
                    if(span == null)
                    {
                        return false;
                    }

                    var id = parseInt(span.dataset.id);
                    Rds.changeStation(id);
                    break;
            }
        }
        
        return false;
    }, false);
    
    document.addEventListener('mousewheel', function(ev){
        ev.preventDefault();
        ev.stopPropagation();
        
        return false;
    }, false);

    window.onselectstart = function(){ return false; } 
    window.onmouseup = function(){ return false; }
    window.onmousedown = function(){ return false; }

    textSelecting = function(container){
        var $con = $(container)[0];
        $con.onselectstart = null;
        $con.onmouseup = null;
        $con.onmousedown = null;
        
        $con.addEventListener('mousedown', function(ev){
            window.onselectstart = null;
            window.onmouseup = null;
            window.onmousedown = null;
        }, true);
        $con.addEventListener('mouseup', function(ev){
            window.onselectstart = function(){ return false; } 
            window.onselectstart = function(){ return false; } 
            window.onmouseup = function(){ return false; }
            window.onmousedown = function(){ return false; }
        }, false);
        $con.addEventListener('mouseout', function(ev){
            window.onselectstart = function(){ return false; } 
            window.onmouseup = function(){ return false; }
            window.onmousedown = function(){ return false; }
        }, false);
    }
    
    textSelecting('#playlist');
    textSelecting('#lyrics');
    
    window.resizeTo(420, 535);
    
    if(Rds.nowplaying == 'hide')
    {
        $('body')[0].className = 'narrow';
        window.resizeBy(0, -130);
        Rds.uiNowplayingResized = true;
    }
    
    if(Rds.lyrics == 'hide' && Rds.bottom == 'hide')
    {
        window.resizeBy(0, -374);
    }
    
    if(Rds.bottom == 'show')
    {
        window.resizeBy(0, -240);
    }
    
    fancyInputs();
    
    u = setInterval(Rds.update, 5000);
    
    // workaround for hotkeys
    // disabled now by line 608
    /*setInterval(function(){
        window.focus();
    }, 1000);*/
}, false);