/*
    --------------------------------------------------------------------
                             RMF RDS Widget
                Copyright (c) 2007-2012 Jacek Jędrzejewski
                    http://www.jacek.jedrzejewski.name/
                          All rights reserved.
    --------------------------------------------------------------------

    This file is part of RMF RDS Widget.
*/

Rds.extend({
    openPlayer: function(id){
        if(Rds.stationList[id].slug === false)
        {
            return false;
        }
        
        widget.openURL('http://www.rmfon.pl/radia/'+Rds.stationList[id].slug+'.html');
        
        return false;
    },
    
    StarImg: function(i, typimg, avgint, avg, allowvoting){
        var gw = '<img id="star'+i+'" style="padding-right:3px;" src="images/star'+typimg+'.png" alt="'+(allowvoting ? i : avg)+'" align="absmiddle">';
        if(allowvoting)
        {
            return '<a title="'+I18N._('rate_song', {number: i})+'" data-i18n="rate_song" data-i18n-target="title" data-i18n-params="{&quot;number&quot;: '+i+'}" onmouseover="Rds.VoteShow('+i+','+avg+')" onmouseout="Rds.VoteShow(-1,'+avg+')" onmouseup="Rds.SendVote('+Rds.song.idu+','+i+')">'+gw+'</a>';
        }
        else
        {
            return gw;
        }
    },
    
    VoteShow: function(i, voting){
        i = parseInt(i);
        if(i == -1)
        {
            for(j = 1; j <= 5; j++)
            {
                if(voting <= j-0.75)
                {
                    $('#star'+j)[0].setAttribute('src', 'images/star0.png');
                }
                else if(voting >= j-0.75 && voting < j-0.25)
                {
                    $('#star'+j)[0].setAttribute('src', 'images/star5.png');
                }
                else
                {
                    $('#star'+j)[0].setAttribute('src', 'images/star1.png');
                }
            }
        }
        else
        {
            for(j = 1; j <= i; j++)
            {
                $('#star'+j)[0].setAttribute('src', 'images/star2.png');
            }
            for(j = i+1; j <= 5; j++)
            {
                $('#star'+j)[0].setAttribute('src', 'images/star0.png');
            }
        }
    },
    
    UpdateSongVoting: function(){
        Rds._UpdateVoting({
            points: Rds.song.points,
            votes: Rds.song.votes,
            allow: true
        });
    },
    
    SendVote: function(idsong, pkt){
        if(event.button != 0) return false;
        
        $('#StripVote')[0].innerHTML = '<span class="wait">'+I18N._('sending')+'</span>';
        $('#StripResult')[0].innerText = '';
        $('#song #score')[0].innerHTML = '';
        
        $req = new XMLHttpRequest();
        $req.onreadystatechange = function()
        {
            if($req.readyState == 4 && $req.status == 200)
            {
                try
                {
                    var res = eval('('+$req.responseText+')');
                }
                catch(e)
                {
                    return false;
                }
                
                res.allow = false;
                
                Rds._UpdateVoting(res);
            }
            else if($req.readyState == 4)
            {
                opera.postError('0x91 XHR Vote: '+$req.status+' '+$req.statusText);
            }
        }
        $req.open("POST", 'http://www.rmfon.pl/stations/vote.html', true);
        params = 'trackId='+Rds.song.trackId+'&points='+pkt+'&stationId='+Rds.currentStation;
        
        $req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        $req.setRequestHeader("Content-length", params.length);
        $req.setRequestHeader("Connection", "close");
        try
        {
            $req.send(params);
        }
        catch(exception)
        {
            opera.postError('0x90 XHR Vote EXCEPTION: '+exception);
        }
    },
    
    _UpdateVoting: function(res){
        $('#StripVote')[0].innerText = '';
        $('#StripResult')[0].innerText = '';
        $('#song #score')[0].innerHTML = '0.0';
        var avgint = avg = avgavg = 0;
        if(res.votes > 0)
        {
            avg = res.points/res.votes;
            avgint = Math.round(avg);
            avgavg = Math.round(100*avg)/100;
            
            $('#song #score')[0].innerHTML = avgavg.toFixed(1);
        }
        var gwiazdki = '';
        
        for(var i = 1; i <= 5; i++)
        {
            if(avgavg <= i-0.75)
            {
                gwiazdki += Rds.StarImg(i, 0, avgint, avgavg, res.allow);
            }
            else if(avgavg > i-0.75 && avgavg <= i-0.25)
            {
                gwiazdki += Rds.StarImg(i, 5, avgint, avgavg, res.allow);
            }
            else
            {
                gwiazdki += Rds.StarImg(i, 1, avgint, avgavg, res.allow);
            }
        }
        
        $('#StripVote')[0].innerHTML = gwiazdki;
    }
});