/*
    --------------------------------------------------------------------
                             RMF RDS Widget
                Copyright (c) 2007-2012 Jacek Jędrzejewski
                    http://www.jacek.jedrzejewski.name/
                          All rights reserved.
    --------------------------------------------------------------------

    This file is part of RMF RDS Widget.
*/

Rds.extend({
    lyricsScroll: false,
    stationScroll: false,
    
    lyricsDrag: false,
    mainDrag: false,
    
    draggingActive: false,
    
    _stationScrollStart: 0,
    
    updateStationsInterval: false,
    
    stationListInitialized: false,
    
    stationListOrder: [],
    tempAllStationList: [],
    tempFavouriteStationList: [],
    
    animations: true,
    
    userFavorites: [],

    nowplaying: 'show',
    uiNowplayingResized: false,
    showNowplaying: function(){
        //if(event.button != 0) return false;
        
        animNP.stop();
        nowplaying = $('#nowplaying')[0];
        
        if(Rds.nowplaying == 'show')
        {
            Rds.nowplaying = 'hide';
            
            var callback = function(){
                Rds.nowplaying = 'hide';
                $('body')[0].className = 'narrow';
                window.resizeBy(0, -130);
                window.moveBy(0, 130);
                Rds.uiNowplayingResized = true;
            };
            
            if(Rds.animations)
            {
                animNP.addAnimation('top', $('#nowplaying')[0].style.top, '160px');
                
                animNP.onfinish = callback;
                
                animNP.run();
            }
            else
            {
                $('#nowplaying')[0].style.top = '160px';
                callback();
            }

            widget.setPreferenceForKey('hide', 'rds_nowplaying');
        }
        else
        {
            $('body')[0].className = '';
            
            if(Rds.uiNowplayingResized)
            {
                window.resizeBy(0, 130);
                window.moveBy(0, -130);
                Rds.uiNowplayingResized = false;
            }
            
            Rds.nowplaying = 'show';
            widget.setPreferenceForKey('show', 'rds_nowplaying');
            
            if(Rds.animations)
            {
                animNP.addAnimation('top', $('#nowplaying')[0].style.top, '0');
                
                animNP.onfinish = function(){
                    Rds.nowplaying = 'show';
                }
                
                animNP.run();
            }
            else
            {
                Rds.nowplaying = 'show';
                $('#nowplaying')[0].style.top = '0';
            }
        }
    },
    
    bottom: 'show',
    bottomActive: 'playlist',
    bottomState: 'short',
    showBottom: function(state, callback){
        //if(event.button != 0) return false;
        
        animBO.stop();
        if(Rds.bottom == 'show')
        {
            clearInterval(Rds.updateStationsInterval);
            Rds.bottom = 'hide';
            
            var onFinishCallback = function(){
                $('#bottomcnt')[0].style.display = 'none';
                if(Rds.bottomState == 'long')
                {
                    window.resizeBy(0, -204);
                }
                else
                {
                    window.resizeBy(0, -134);
                }
                if(typeof callback == 'function')
                {
                    callback();
                }
            }
            
            if(Rds.animations)
            {
                animBO.addAnimation('top', $('#bottom')[0].style.top, '-210px');
                animBO.onfinish = onFinishCallback;
                animBO.run();
            }
            else
            {
                $('#bottom')[0].style.top = '-210px';
                onFinishCallback();
            }
            
            widget.setPreferenceForKey('hide', 'rds_playlist');
        }
        else if(Rds.bottom == 'lyrics' && Rds.lyrics != 'show')
        {
            Rds.showLyrics();
        }
        else
        {
            animateShow = function(){
                $('#bottomcnt')[0].style.display = 'block';
                Rds.bottom = 'show';
                
                if(Rds.bottomActive == 'stations')
                {
                    Rds.updateStations();
                    Rds.updateStationsInterval = setInterval(Rds.updateStations, 20000);
                }
                
                widget.setPreferenceForKey('show', 'rds_playlist');
                    
                if(Rds.animations)
                {
                    if(state == 'long' || Rds.bottomState == 'long')
                    {
                        animBO.addAnimation('top', $('#bottom')[0].style.top, '0');
                        Rds.bottomState = 'long';
                        window.resizeBy(0, 204);
                    }
                    else
                    {
                        animBO.addAnimation('top', $('#bottom')[0].style.top, '-70px');
                        Rds.bottomState = 'short';
                        window.resizeBy(0, 134);
                    }
                    
                    animBO.onfinish = function(){
                        if(typeof callback == 'function')
                        {
                            callback();
                        }
                    }
                    
                    animBO.run();
                }
                else
                {
                    if(state == 'long' || Rds.bottomState == 'long')
                    {
                        $('#bottom')[0].style.top = '0';
                        Rds.bottomState = 'long';
                        window.resizeBy(0, 204);
                    }
                    else
                    {
                        $('#bottom')[0].style.top = '-70px';
                        Rds.bottomState = 'short';
                        window.resizeBy(0, 134);
                    }
                    
                    if(typeof callback == 'function')
                    {
                        callback();
                    }
                }
            }
            
            if(Rds.lyrics == 'show')
            {
                if(!state)
                {
                    Rds.showLyrics(false);
                }
                else
                {
                    Rds.showLyrics(animateShow);
                }
            }
            else
            {
                animateShow();
            }
        }
    },
    
    hidePanel: function(callback){
        var animOBJ;
        var $baseOBJ;
        
        switch(Rds.bottomActive)
        {
            case 'playlist':
                animOBJ = animPanelPL;
                $baseOBJ = $('#playlist')[0];
                break;
            case 'stations':
                animOBJ = animPanelST;
                $baseOBJ = $('#stationsbox')[0];
                break;
            case 'settings':
                animOBJ = animPanelSE;
                $baseOBJ = $('#settings')[0];
                break;
            case 'about':
                animOBJ = animPanelAB;
                $baseOBJ = $('#about')[0];
                break;
        }
        
        if(Rds.animations)
        {
            animOBJ.addAnimation('opacity', $baseOBJ.style.opacity, 0);
            animOBJ.onfinish = function(){
                $baseOBJ.style.display = 'none';
                callback();
            }
            animOBJ.run();
        }
        else
        {
            $baseOBJ.style.opacity = 0;
            $baseOBJ.style.display = 'none';
            callback();
        }
    },
    
    showPlaylist: function(){
        //if(event.button != 0) return false;
        
        clearInterval(Rds.updateStationsInterval);
        
        if(Rds.bottom == 'show')
        {    
            if(Rds.bottomState == 'long')
            {
                animBO.stop();
                
                if(Rds.animations)
                {
                    animBO.addAnimation('top', $('#bottom')[0].style.top, '-70px');
                    
                    animBO.onfinish = function(){
                        window.resizeBy(0, -70);
                    }
                    
                    animBO.run();
                }
                else
                {
                    $('#bottom')[0].style.top = '-70px';
                    window.resizeBy(0, -70);
                }
                
                Rds.bottomState = 'short';
            }
            
            if(Rds.bottomActive != 'playlist')
            {
                this.hidePanel(function(){
                    Rds.bottomActive = 'playlist';
                    $('#playlist')[0].style.display = 'block';
                    
                    if(Rds.animations)
                    {
                        animPanelPL.addAnimation('opacity', $('#playlist')[0].style.opacity, 1);
                        animPanelPL.onfinish = function(){  }
                        animPanelPL.run();
                    }
                    else
                    {
                        $('#playlist')[0].style.opacity = 1;
                    }
                });
            }
        }
        else
        {
            $('#about')[0].style.display = 'none';
            $('#about')[0].style.opacity = 0;
            $('#settings')[0].style.display = 'none';
            $('#settings')[0].style.opacity = 0;
            $('#stationsbox')[0].style.display = 'none';
            $('#stationsbox')[0].style.opacity = 0;
            $('#playlist')[0].style.display = 'block';
            $('#playlist')[0].style.opacity = 1;
            
            Rds.bottomActive = 'playlist';
            
            Rds.bottomState = 'short';
            Rds.showBottom('short');
        }        
    },
    
    initializeStationsScroll: function(){
        if(Rds.stationScroll == false)
        {
            Rds.stationScroll = new Scroller($('#stationsbox')[0], $('#stationsbox div.scroll')[0], $('#stations')[0], $('#stations div.cont')[0]);
            Rds.stationScroll.scrollTo(Rds._stationScrollStart);
        }
        
        if(!Rds.stationListInitialized)
        {
            $('#bottomcnt')[0].style.display = 'block';
            
            var stations = $('#stations li');
            var i;
            for(i in stations)
            {
                $('em', stations[i])[0].style.maxWidth = (340 - $('span', stations[i])[0].offsetWidth)+'px';
            }
            
            Rds.stationListInitialized = true;
        }
    },
    
    showStations: function(){
        //if(event.button != 0) return false;
        
        Rds.updateStations();
        Rds.updateStationsInterval = setInterval(Rds.updateStations, 20000);
        
        if(Rds.stationScroll == false)
        {
            $('#bottomcnt')[0].style.display = 'block';
        }
        
        if(Rds.bottom == 'show')
        {
            if(Rds.bottomState == 'short')
            {
                animBO.stop();
                window.resizeBy(0, 70);
                
                if(Rds.animations)
                {
                    animBO.addAnimation('top', $('#bottom')[0].style.top, '0');
                    animBO.onfinish = function(){  }
                    
                    animBO.run();
                }
                else
                {
                    $('#bottom')[0].style.top = '0';
                }
                
                Rds.bottomState = 'long';
            }
            
            if(Rds.bottomActive != 'stations')
            {
                this.hidePanel(function(){
                    Rds.bottomActive = 'stations';
                    $('#stationsbox')[0].style.display = 'block';
                    
                    if(Rds.animations)
                    {
                        animPanelST.addAnimation('opacity', $('#stationsbox')[0].style.opacity, 1);
                        animPanelST.onfinish = Rds.initializeStationsScroll;
                        animPanelST.run();
                    }
                    else
                    {
                        $('#stationsbox')[0].style.opacity = 1;
                        Rds.initializeStationsScroll();
                    }
                });
            }
        }
        else
        {
            $('#about')[0].style.display = 'none';
            $('#about')[0].style.opacity = 0;
            $('#settings')[0].style.display = 'none';
            $('#settings')[0].style.opacity = 0;
            $('#stationsbox')[0].style.display = 'block';
            $('#stationsbox')[0].style.opacity = 1;
            $('#playlist')[0].style.display = 'none';
            $('#playlist')[0].style.opacity = 0;
            
            Rds.bottomActive = 'stations';
            
            Rds.bottomState = 'long';
            Rds.showBottom('long', Rds.initializeStationsScroll);
        }
    },
    
    showSettings: function(force){
        force |= false;
        
        if(!force && event.button != 0) return false;
        
        clearInterval(Rds.updateStationsInterval);
        
        if(Rds.bottom == 'show')
        {
            if($('#settings')[0].style.display == 'block')
            {
                return false;
            }
            
            if(Rds.bottomState == 'long')
            {
                animBO.stop();
                
                if(Rds.animations)
                {
                    animBO.addAnimation('top', $('#bottom')[0].style.top, '-70px');
                    
                    animBO.onfinish = function(){
                        window.resizeBy(0, -70);
                    }
                    
                    animBO.run();
                }
                else
                {
                    $('#bottom')[0].style.top = '-70px';
                    window.resizeBy(0, -70);
                }
                
                Rds.bottomState = 'short';
            }
            
            this.hidePanel(function(){
                Rds.bottomActive = 'settings';
                $('#settings')[0].style.display = 'block';
                
                if(Rds.animations)
                {
                    animPanelSE.addAnimation('opacity', $('#settings')[0].style.opacity, 1);
                    animPanelSE.onfinish = function(){  }
                    animPanelSE.run();
                }
                else
                {
                    $('#settings')[0].style.opacity = 1;
                }
            });
        }
        else
        {
            $('#about')[0].style.display = 'none';
            $('#about')[0].style.opacity = 0;
            $('#settings')[0].style.display = 'block';
            $('#settings')[0].style.opacity = 1;
            $('#stationsbox')[0].style.display = 'none';
            $('#stationsbox')[0].style.opacity = 0;
            $('#playlist')[0].style.display = 'none';
            $('#playlist')[0].style.opacity = 0;
            
            Rds.bottomActive = 'settings';
            
            Rds.bottomState = 'short';
            Rds.showBottom('short');
        }
    },
    
    showAbout: function(){
        //if(event.button != 0) return false;
        
        clearInterval(Rds.updateStationsInterval);
        
        if(Rds.bottom == 'show')
        {
            if($('#about')[0].style.display == 'block')
            {
                return false;
            }
            
            if(Rds.bottomState == 'long')
            {
                animBO.stop();
                
                if(Rds.animations)
                {
                    animBO.addAnimation('top', $('#bottom')[0].style.top, '-70px');
                    
                    animBO.onfinish = function(){
                        window.resizeBy(0, -70);
                    }
                    
                    animBO.run();
                }
                else
                {
                    $('#bottom')[0].style.top = '-70px';
                    window.resizeBy(0, -70);
                }
                
                Rds.bottomState = 'short';
            }
            
            this.hidePanel(function(){
                Rds.bottomActive = 'about';
                $('#about')[0].style.display = 'block';
                
                if(Rds.animations)
                {
                    animPanelAB.addAnimation('opacity', $('#about')[0].style.opacity, 1);
                    animPanelAB.onfinish = function(){  }
                    animPanelAB.run();
                }
                else
                {
                    $('#about')[0].style.opacity = 1;
                }
            });
        }
        else
        {
            $('#about')[0].style.display = 'block';
            $('#about')[0].style.opacity = 1;
            $('#settings')[0].style.display = 'none';
            $('#settings')[0].style.opacity = 0;
            $('#stationsbox')[0].style.display = 'none';
            $('#stationsbox')[0].style.opacity = 0;
            $('#playlist')[0].style.display = 'none';
            $('#playlist')[0].style.opacity = 0;
            
            Rds.bottomActive = 'about';
            
            Rds.bottomState = 'short';
            Rds.showBottom('short');
        }
    },
    
    playFakty: function(value, set){
        set |= true;
        if(typeof(value) == 'undefined')
        {
            value = 'yes';
            if(Rds.fakty == 'yes')
            {
                value = 'no';
            }
        }
        Rds.fakty = value;
        
        var span = $('#nowplaying #song .station span')[0];
        
        if(value == 'yes')
        {
            span.className = 'fakty_active';
            fadd = '-facts';
            span.setAttribute('title', I18N._('facts_disable'));
        }
        else
        {
            span.className = 'fakty_inactive';
            fadd = '';
            span.setAttribute('title', I18N._('facts_enable'));
        }
        if(in_array(Rds.currentStation, Rds.showFakty) && set)
        {
            Rds.streaming.setURL('http://files.kusmierz.be/rmf/'+Rds.info.stream+fadd);
            
            if(Rds.musicState == 'stop')
            {
                Rds.streaming.stop();
            }
            if(Rds.musicState == 'play')
            {
                Rds.streaming.play();
            }
        }
        
        widget.setPreferenceForKey(Rds.fakty, 'play_fakty');
    },

    stationList: function(currentStationPosition){
        var lis = $('#stations ul li');
        
        var count = lis.length-1;
        var start = currentStationPosition - 5;
        var finish = currentStationPosition + 6;
        
        if(start < 0)
        {
            finish -= start;
            start = 0;
        }
        
        if(finish > count)
        {
            start -= finish-count;
            finish = count;
        }
        start = parseInt(start);

        Rds._stationScrollStart = 0-start*15;
    },
    
    lyrics: 'hide',
    initializeLyricsScroll: function(){
        if(!Rds.lyricsScroll)
        {
            Rds.lyricsScroll = new Scroller($('#lyricscnt')[0], $('#lyricscnt div.scroll')[0], $('#lyrics div.cont')[0], $('#lyrics div.cont div.text')[0]);
        }
    },
    showLyrics: function(callback){
        //if(event.button != 0) return false;
        
        animLY.stop();
        if(Rds.lyrics == 'hide')
        {
            animateShow = function(){
                Rds.lyrics = 'show';
                Rds.bottom = 'lyrics';
                window.resizeBy(0, 374);
                
                $('#lyricscnt')[0].style.display = 'block';
                widget.setPreferenceForKey('yes', 'display_lyrics');
                Rds.initializeLyricsScroll();
                Rds.updateLyrics();
                
                if(Rds.animations)
                {
                    animLY.addAnimation('top', $('#lyrics')[0].style.top, '0');
                    animLY.onfinish = function(){  }
                    animLY.run();
                }
                else
                {
                    $('#lyrics')[0].style.top = '0';
                }
            }
            
            if(Rds.bottom == 'show')
            {
                Rds.showBottom(null, animateShow);
            }
            else
            {
                animateShow();
            }
        }
        else if(typeof callback == typeof Function || callback === false)
        {
            var onFinishCallback = function(){
                Rds.lyrics = 'hide';
                
                window.resizeBy(0, -374);
                $('#lyricscnt')[0].style.display = 'none';
                widget.setPreferenceForKey('no', 'display_lyrics');
                
                if(typeof callback == typeof Function)
                {
                    callback();
                }
            }
        
            if(Rds.animations)
            {
                animLY.addAnimation('top', $('#lyrics')[0].style.top, '-384px');
            
                animLY.onfinish = onFinishCallback;
                
                animLY.run();
            }
            else
            {
                $('#lyrics')[0].style.top = '-384px';
                onFinishCallback();
            }
        }
    },
    
    titleScrollerInterval: 0,
    titleScrollerTimeout: 0,
    titleScroller: function(){
        clearInterval(Rds.titleScrollerInterval);
        clearTimeout(Rds.titleScrollerTimeout);
        var $p = $('#title p')[0];
        $p.style.left = '0';
        var $container = $('#title')[0];
        var width = $p.offsetWidth;
        var containerWidth = parseInt($container.offsetWidth);
        
        if(width > containerWidth)
        {
            var delta = width - containerWidth;
            goLeft = function()
            {
                if(Rds.animations)
                {
                    Rds.titleScrollerInterval = setInterval(function(){
                        
                        left = Math.abs(parseInt($p.style.left));
                        left++;
                        $p.style.left = '-'+left+'px';
                        if(left == delta)
                        {
                            clearInterval(Rds.titleScrollerInterval);
                            clearTimeout(Rds.titleScrollerTimeout);
                            Rds.titleScrollerTimeout = setTimeout(goRight, 1000);
                            return false;
                        }
                    }, 50);
                }
                else
                {
                    Rds.titleScrollerInterval = setInterval(function(){
                        left = Math.abs(parseInt($p.style.left));
                        left++;
                        $p.style.left = '-'+delta+'px';
                        
                        clearInterval(Rds.titleScrollerInterval);
                        clearTimeout(Rds.titleScrollerTimeout);
                        Rds.titleScrollerTimeout = setTimeout(goRight, 1000);
                        return false;
                    }, 1500);
                }
            }
            goRight = function()
            {
                if(Rds.animations)
                {
                    Rds.titleScrollerInterval = setInterval(function(){
                        left = Math.abs(parseInt($p.style.left));
                        left--;
                        $p.style.left = '-'+left+'px';
                        if(left == 0)
                        {
                            clearInterval(Rds.titleScrollerInterval);
                            clearTimeout(Rds.titleScrollerTimeout);
                            Rds.titleScrollerTimeout = setTimeout(goLeft, 1000);
                            return false;
                        }
                    }, 50);
                }
                else
                {
                    Rds.titleScrollerInterval = setInterval(function(){
                        left = Math.abs(parseInt($p.style.left));
                        left--;
                        $p.style.left = '0';
                        
                        clearInterval(Rds.titleScrollerInterval);
                        clearTimeout(Rds.titleScrollerTimeout);
                        Rds.titleScrollerTimeout = setTimeout(goLeft, 1000);
                        return false;
                    }, 1500);
                }
            }
            Rds.titleScrollerTimeout = setTimeout(goLeft, 1000);
        }
    },
    
    musicState: '',
    musicStop: function(){
        if(!Rds.streaming.enabled)
        {
            widget.showNotification(I18N._('no_stream_plugin'));
            return false;
        }
        
        Rds.musicState = 'stop';
        
        if(Rds.streaming.initialized)
        {
            Rds.streaming.stop();
        }
        
        $('#controls span.playback_stop')[0].style.display = 'none';
        $('#controls span.playback_play')[0].style.display = 'block';
        widget.setPreferenceForKey('no', 'play_music');
        
        if(!Rds.always_scrobble)
        {
            AS.clearSong();
        }
    },
    musicPlay: function(dont_change){
        dont_change |= false;
        if(!Rds.streaming.enabled)
        {
            widget.showNotification(I18N._('no_stream_plugin'));
            return false;
        }
        
        Rds.musicState = 'play';
        
        if(!dont_change)
        {
            fadd = '';
            if(Rds.fakty == 'yes' && in_array(Rds.currentStation, Rds.showFakty))
            {
                fadd = '-facts';
            }
            Rds.streaming.setURL('http://files.kusmierz.be/rmf/'+Rds.info.stream+fadd);
        
            Rds.streaming.play();
        }
        
        $('#controls span.playback_stop')[0].style.display = 'block';
        $('#controls span.playback_play')[0].style.display = 'none';
        widget.setPreferenceForKey('yes', 'play_music');
        
        if(!Rds.always_scrobble && Rds.song != '' && Rds.song.title.trim().length > 0 && Rds.song.author.trim().length > 0)
        {
            AS.setSong(Rds.song.title.trim(), Rds.song.author.trim(), Rds.song.recordTitle.trim());
        }
    },
    musicVolumeValue: 0,
    musicVolume: function(volume, updateHandle, onlyHandle){
        if(!Rds.streaming.enabled)
        {
            widget.showNotification(I18N._('no_stream_plugin'));
            return false;
        }
        if(volume < 0)
        {
            volume = 0;
        }
        if(volume > 100)
        {
            volume = 100;
        }
        
        updateHandle |= false;
        onlyHandle |= false;
        
        if(!onlyHandle)
        {
            Rds.streaming.setVolume(volume);
        }
        
        if(updateHandle)
        {
            $('#volumeInner div.handle')[0].style.left = (Math.round(volume * (114-14) / 100))+'px';
        }
        
        widget.setPreferenceForKey(volume, 'play_music_volume');
        Rds.musicVolumeValue = volume;
        
        $('#volumeInner div.handle')[0].setAttribute('title', volume+'%');
        
        if(volume > 0 && Rds.musicMuteHold)
        {
            Rds.musicMuteState = false;
        }
        
        handle = $('div#bSpeaker div.speaker')[0];
        
        if(volume == 0 && !handle.hasClass('volume_mute'))
        {
            handle.removeClass('volume_full');
            handle.addClass('volume_mute');
        }
        else if(volume > 0 && !handle.hasClass('volume_full'))
        {
            handle.removeClass('volume_mute');
            handle.addClass('volume_full');
        }
    },
    musicMuteHold: 0,
    musicMuteState: false,
    musicMute: function(){
        if(!Rds.musicMuteState)
        {
            Rds.musicMuteHold = Rds.musicVolumeValue;
            Rds.musicVolume(0, true);
            Rds.musicMuteState = true;
            $('#bSpeaker .speaker')[0].setAttribute('title', I18N._('button_unmute'));
            $('#bSpeaker .speaker')[0].dataset.i18n = 'button_unmute';
        }
        else
        {
            Rds.musicVolume(Rds.musicMuteHold, true);
            Rds.musicMuteState = false;
            $('#bSpeaker .speaker')[0].setAttribute('title', I18N._('button_mute'));
            $('#bSpeaker .speaker')[0].dataset.i18n = 'button_mute';
        }
    }
});