/*
    --------------------------------------------------------------------
                             RMF RDS Widget
                Copyright (c) 2007-2012 Jacek Jędrzejewski
                    http://www.jacek.jedrzejewski.name/
                          All rights reserved.
    --------------------------------------------------------------------

    This file is part of RMF RDS Widget.
*/

Rds.extend({
    // scrobble to last.fm even the radio playback is turned of
    always_scrobble: false,

    changeStation: function(id){
        Rds.currentTst = 0;
        Rds.lastSongId = 0;
        
        Rds.clearRdsSong();
        
        Rds.updateLyrics(true);

        $('#song div.album img.album_gfx')[0].setAttribute('src', 'images/blank.png');
        $('#song .artist')[0].innerHTML = '<span data-i18n="loading_in_progress">'+I18N._('loading_in_progress')+'</span>';
        $('#song .title')[0].innerText = '';
        $('#song .cover')[0].innerText = '';
        
        $('#StripVote')[0].innerText = '';
        $('#StripResult')[0].innerText = '';
        $('#song #score')[0].innerHTML = '';
        
        var artist = $('#title .artist')[0];
        artist.innerHTML = '<span data-i18n="loading_in_progress">'+I18N._('loading_in_progress')+'</span>';
        $('#title .title')[0].innerText = '';
        Rds.titleScroller();
        
        var $lis = $('#playlist li');
        
        for(var i in $lis)
        {
            $lis[i].parentNode.removeChild($lis[i]);
        }
        
        $('#stationsbox li.current')[0].removeClass('current');
        
        $('#song_station')[0].style.display = 'none';
        $('#song')[0].style.display = 'block';
        
        widget.setPreferenceForKey(id, 'rds_id');
        Rds.changeStationInfo(id);
        
        Rds.update();
    },
    
    changeStationInfo: function(id){
        if(Rds.stationList[id] == null)
        {
            id = 5;
        }
        
        Rds.currentStation = id;
        Rds.info = Rds.stationList[id];
        
        $('.station #stationimg')[0].setAttribute('src', 'images/logos/'+Rds.info.key+'.png');
        
        $('#nowplaying .nowplaying strong')[0].innerText = Rds.info.name;
        $('#nowplaying .nowplaying span')[0].innerText = Rds.info.name;

        $('#stationsbox #st'+id)[0].addClass('current');
        
        if(in_array(id, Rds.showFakty))
        {
            $('#nowplaying #song .station span')[0].style.display = 'inline-block';
        }
        else
        {
            $('#nowplaying #song .station span')[0].style.display = 'none';
        }
          
        if(Rds.streaming && Rds.streaming.enabled)
        {
            Rds.streaming.setURL(this.getStationStreamURL());
        }
    },
    
    getStationStreamURL: function(){
        fadd = '';
        
        if(Rds.fakty == 'yes' && in_array(Rds.currentStation, Rds.showFakty))
        {
            fadd = '-facts';
        }
        
        return 'http://files.kusmierz.be/rmf/'+Rds.info.stream+fadd;
    },

    stationsOnHover: [],
    $req_us: new XMLHttpRequest(),
    updateStations: function(){
        try
        {
            Rds.$req_us.abort();
            Rds.$req_us = new XMLHttpRequest();
            Rds.$req_us.onreadystatechange = function(){
                if(Rds.$req_us.readyState == 4 && Rds.$req_us.status == 200)
                {
                    try
                    {
                        eval("var resp = ("+Rds.$req_us.responseText+')');
                    }
                    catch(exception)
                    {
                        opera.postError('0x21 XHR All Stations NP EXCEPTION: '+exception);
                        //opera.postError(Rds.$req_us.responseText);
                        return false;
                    }
                    
                    var lis = $('#stations ul li.station');
                    var i;
                    for(i in lis)
                    {
                        var id = $('span', lis[i])[0].dataset.id;
                        eval('var radio = resp.radio'+id);
                        if(radio == undefined) continue;
                        
                        var em = $('em', lis[i])[0];
                        if(radio.id_autor != '')
                        {
                            if(radio.duza_biografia == '1')
                            {
                                em.innerHTML = '<a data-id="'+radio.id_autor+'" title="'+radio.name+' - '+radio.utwor+'">'+radio.name+'</a>';
                                $('a', em)[0].addEventListener('click', function(ev){
                                    if(ev.button != 0) return false;
                                    id_autor = this.dataset.id;
                                    if(id_autor.strlen == 0)
                                    {
                                        return false;
                                    }
                                    widget.openURL('http://www.rmfon.pl/artysci/'+this.dataset.id+'.html');
                                    return false;
                                }, false);
                            }
                            else
                            {
                                em.innerHTML = '<a title="'+radio.name+' - '+radio.utwor+'">'+radio.name+'</a>';
                            }
                            
                            Rds.stationsOnHover[id] = radio;
                            
                        }
                        else
                        {
                            em.innerText = radio.name;
                        }
                    }
                }
                else if(Rds.$req_us.readyState == 4)
                {
                    opera.postError('0x22 XHR All Stations NP: '+Rds.$req_us.status+' '+Rds.$req_us.statusText);
                }
            }
            Rds.$req_us.open("GET", 'http://www.rmfon.pl/stacje/ajax_playing_main.txt', true);
            Rds.$req_us.send();
        }
        catch(exception)
        {
            opera.postError('0x20 XHR All Stations NP EXCEPTION: '+exception);
        }
    },
    
    updateStationNowPlaying: function(id){
        coverSrc = $('#song_station div.album img.album_gfx')[0];
        coverSrc.style.display = 'none';
        
        radio = Rds.stationsOnHover[id];
        if(radio == undefined)
        {
            $('#song_station .artist')[0].innerHTML = '<span data-i18n="no_song_info">'+I18N._('no_song_info')+'</span>';
            $('#song_station .title')[0].innerHTML = '';
            $('#song_station .cover')[0].innerText = '';
            coverSrc.setAttribute('src', 'images/blank2.png');
            coverSrc.style.display = 'block';
            return true;
        }
        
        $('#song_station .artist')[0].innerHTML = '<a title="'+radio.name+'">'+radio.name+'</a>';
        $('#song_station .title')[0].innerHTML = radio.utwor;
        
        if(radio.plyta.length > 0)
        {
            var covertext = '';
            if(radio.plyta.length > 0)
            {
                covertext = radio.plyta;
            }
            
            if(radio.rok.length > 0)
            {
                covertext = covertext+' / '+radio.rok;
            }
            
            $('#song_station .cover')[0].innerHTML = covertext;
        }
        else
        {
            $('#song_station .cover')[0].innerText = '';
        }
        
        coverSrc.style.display = 'block';
        if(radio.id_plyta == '')
        {    
            coverSrc.setAttribute('src', 'images/stopper.png');
        }
        else
        {
            subdir = Math.floor(eval(radio.id_plyta)/1000);
            coverSrc.setAttribute('src', radio.cover);
        }
    },
    
    $req_up: new XMLHttpRequest(),
    $req_pl: new XMLHttpRequest(),
    updatePreviousStationId: 0,
    update: function(){
        var current = false;
        
        try
        {
            Rds.$req_pl.abort();
            Rds.$req_pl = new XMLHttpRequest();
            Rds.$req_pl.onreadystatechange = function(){
                if(Rds.$req_pl.readyState == 4 && Rds.$req_pl.status == 200)
                {
                    try
                    {
                        eval("var resp = ("+Rds.$req_pl.responseText+')');
                    }
                    catch(exception)
                    {
                        opera.postError('0x42 XHR Playlist EXCEPTION: '+exception);
                        return false;
                    }
                    
                    var $lis = $('#playlist li');
                    
                    for(var i in $lis)
                    {
                        $lis[i].parentNode.removeChild($lis[i]);
                    }
                    
                    var $pl = $('#playlist')[0];
                    for(var i = 0; i < resp.length && i < 7; i++)
                    {
                        var item = resp[i];
                        var li = document.createElement('li');
                        
                        li.id = 'l'+item.timestamp;
                        
                        if(item.order == 0)
                        {
                            li.className = 'current';
                            current = item;
                        }
                        
                        var artist = '<em>'+item.author.trim()+'</em>';
                        
                        
                        if(item.bio && item.hasBiography)
                        {
                            artist = '<a href="http://www.rmfon.pl/artysci/'+item.bio+'.html" data-artist-id="'+item.bio+'">'+item.author+'</a>';
                        }
                        
                        li.innerHTML = '<time>'+item.start.substr(0,5)+'</time> '+artist+' <strong>'+item.title+'</strong>';
                        
                        $pl.appendChild(li);
                    }
                    
                    if(current === false)
                    {
                        $('#title .artist')[0].innerText = '';
                        $('#title .title')[0].innerHTML = '<span data-i18n="no_song_info">'+I18N._('no_song_info')+'</span>';
                        
                        $('#song .artist')[0].innerHTML = '<span data-i18n="no_song_info">'+I18N._('no_song_info')+'</span>';
                        $('#song .title')[0].innerText = '';
                        $('#song .cover')[0].innerText = '';
                        
                        $('#StripVote')[0].innerText = '';
                        $('#StripResult')[0].innerText = '';
                        $('#song #score')[0].innerText = '';
                        
                        document.title = Rds.info.name;
                        
                        Rds.clearRdsSong();
                        
                        Rds.updateLyrics(true);
                        
                        $('#song div.album img.album_gfx')[0].setAttribute('src', 'images/blank2.png');
                        
                        Rds.clearCurrentSong();
                        
                        if(Rds.musicState == 'play' || Rds.always_scrobble)
                        {
                            AS.clearSong();
                        }
                        
                        if(Rds.lastSongId != '' || Rds.updatePreviousStationId != Rds.currentStation)
                        {
                            Rds.updatePreviousStationId = Rds.currentStation;
                            Rds.titleScroller();
                        }
                        
                        Rds.lastSongId = '';
                    }
                    else if(Rds.song.selector != current.selector || Rds.song.trackId != current.trackId || Rds.song.author != current.author)
                    {
                        Rds.song = current;
                        
                        $('#title .artist')[0].innerHTML = current.author.trim();
                                    
                        $('#title .title')[0].innerHTML = current.title.trim();
                                    
                        Rds.titleScroller();

                        $('#song .artist')[0].innerHTML = '<a title="'+current.author.trim()+'">'+current.author.trim()+'</a>';
                                    
                        $('#song .artist a')[0].addEventListener('mouseup', function(ev){
                            if(ev.button != 0) return false;
                            
                            if(current.bio != 0)
                            {
                                widget.openURL('http://www.rmfon.pl/artysci/'+current.bio+'.html');
                            }
                            return false;
                        }, false);
                                    
                                    
                        var docTitle = '';
                        $('#song .title')[0].innerHTML = '';
                        if(current.title.trim() != '')
                        {
                            $('#song .title')[0].innerHTML = '<span title="'+current.title.trim()+'">'+current.title.trim()+'</span>';
                            
                            docTitle = ' - '+current.title.trim();
                        }
                                    
                        document.title = html_entity_decode(current.author.trim()+docTitle);
                                    
                        if(current.recordTitle.length > 0)
                        {
                            var covertext = '<span class="g_ply" title="'+current.recordTitle+'">'+current.recordTitle+'</span>';
                                        
                            if(current.year > 0)
                            {
                                covertext = covertext+' / <span class="g_year" title="'+current.year+'">'+current.year+'</span>';
                            }
                                        
                            $('#song .cover')[0].innerHTML = covertext;
                        }
                        else
                        {
                            $('#song .cover')[0].innerText = '';
                        }

                        var coverSrc = $('#song div.album img.album_gfx')[0];
                                    
                        if(current.cover == 0)
                        {
                            coverSrc.setAttribute('src', 'images/stopper.png');
                        }
                        else
                        {
                            coverSrc.setAttribute('src', current.coverUrl);
                        }
                                    
                        if((Rds.musicState == 'play' || Rds.always_scrobble) && current.title.trim().length > 0)
                        {
                            AS.setSong(current.title.trim(), current.author.trim(), current.recordTitle.trim());
                        }
                        
                        $('#StripVote')[0].innerText = '';
                        $('#StripResult')[0].innerText = '';
                        $('#song #score')[0].innerText = '';
                        Rds.lastSongId = current.selector;
                        
                        if(Rds.song.trackId != 0)
                        {
                            Rds.UpdateSongVoting();
                        }
                        else
                        {
                            $('#StripVote')[0].innerText = '';
                            $('#StripResult')[0].innerText = '';
                            $('#song #score')[0].innerText = '';
                        }
                        
                        Rds.updateLyrics();
                                    
                        Rds.currentTst = current.timestamp;
                    }
                }
                else if(Rds.$req_pl.readyState == 4)
                {
                    opera.postError('0x41 XHR Playlist: '+Rds.$req_pl.status+' '+Rds.$req_pl.statusText);
                }
            }
            Rds.$req_pl.open("GET", 'http://www.rmfon.pl/stacje/playlista_'+Rds.currentStation+'.json.txt', true);
            Rds.$req_pl.send(null);
        }
        catch(exception)
        {
            opera.postError('0x40 XHR Playlist EXCEPTION: '+exception);
        }
    },
    
    clearRdsSong: function(){
        Rds.song = {
            trackId: 0,
            start: "00:00:00",
            timestamp: 0,
            selector: null,
            hasLyrics: 0
        }
    },
    
    clearCurrentSong: function(){
        var songs = $('#playlist .current');
        if(songs.length > 0)
        {
            var i;
            for(i in songs)
            {
                songs[i].removeClass('current');
            }
        }
    },
    
    lyricsFound: false,
    $req_ly: new XMLHttpRequest(),
    updateLyrics: function(clear){
        clear |= false;
        
        if(Rds.lyrics != 'hide')
        {
            Rds.lyricsScroll.reset();
        }
        
        try
        {
            Rds.$req_ly.abort();
            Rds.$req_ly = new XMLHttpRequest();
            
            Rds.lyricsFound = false;
            
            if(Rds.song.hasLyrics == 0 || clear)
            {
                $('#lyrics div.text')[0].innerHTML = '<span data-i18n="no_lyrics">'+I18N._('no_lyrics')+'</span>';
                Rds.uiLyricsIcon();
            }
            else
            {
                $('#lyrics div.text')[0].innerHTML = '';
                
                Rds.$req_ly.onreadystatechange = function(){
                    if(Rds.$req_ly.readyState == 4)
                    {
                        if(Rds.$req_ly.status == 200)
                        {
                            try
                            {
                                eval("var resp = ("+Rds.$req_ly.responseText+')');
                            }
                            catch(exception)
                            {
                                opera.postError('0x41 XHR Lyrics EXCEPTION: '+exception);
                                return false;
                            }
                            
                            $('#lyrics div.text')[0].innerHTML = resp.lyrics;
                            Rds.lyricsFound = true;
                        }
                        else
                        {
                            $('#lyrics div.text')[0].innerHTML = '<span data-i18n="no_lyrics">'+I18N._('no_lyrics')+'</span>';
                        }
                        
                        if(Rds.lyrics != 'hide')
                        {
                            Rds.lyricsScroll.reset();
                        }
                    }
                    Rds.uiLyricsIcon();
                }
                Rds.$req_ly.open("GET", 'http://www.rmfon.pl/artists/track-lyrics-'+Rds.song.trackId+'.html', true);
                Rds.$req_ly.send(null);
            }
        }
        catch(exception)
        {
            opera.postError('0x50 XHR Lyrics EXCEPTION: '+exception);
        }
    },
    
    uiLyricsIcon: function(){
        if(Rds.lyricsFound)
        {
            $('#bLyrics')[0].addClass('found');
        }
        else
        {
            $('#bLyrics')[0].removeClass('found');
        }
    }
});