/*
    --------------------------------------------------------------------
                             RMF RDS Widget
                Copyright (c) 2007-2012 Jacek Jędrzejewski
                    http://www.jacek.jedrzejewski.name/
                          All rights reserved.
    --------------------------------------------------------------------

    This file is part of RMF RDS Widget.
*/

var mountPoint = opera.io.filesystem.mountSystemDirectory('application', 'app');
    
var I18N = new Base;

I18N.extend({
    constructor: null,
    
    initialized: false,
    locale: 'pl',
    texts: {},
    stations: {},

    setLocale: function(locale){
        this.locale = locale;
        
        var content = this.loadFile('lang.json');

        try
        {
            this.texts = JSON.parse(content);
        }
        catch(e)
        {
            opera.postError('Error parsing '+locale+' lang.json i18n file.');
        }
        
        this.initialized = true;
    },
    
    loadFile: function(filename){
        var dirname = 'locales/'+this.locale;
        var dir = mountPoint.resolve(dirname);
        
        try
        {
            var file = dir.open(filename, opera.io.filemode.READ);
        }
        catch(e)
        {
            opera.postError('Error loading '+filename+' file in '+dirname+': '+e);
            return '';
        }
        
        var content = '';
        var line;
        
        while((line = file.readLine()) !== null)
        {
            content += line;
        }
        
        return content;
    },
    
    _: function(text, argv){
        if(!this.initialized)
        {
            this.setLocale(this.locale);
        }
        
        if(typeof(this.texts[text]) == 'undefined')
        {
            opera.postError('Undefined "'+text+'" i18n string.');
            return '[unknown]';
        }
        
        if(typeof(argv) != 'undefined')
        {
            return sprintf(this.texts[text], argv);
        }
        else
        {
            return this.texts[text];
        }
    },
    
    translateDOM: function(){
        var items = $('[data-i18n]');
        var node, text, params;
        
        for(var i = 0; i < items.length; i++)
        {
            node = items[i];
            
            if(typeof(node.dataset.i18nParams) != 'undefined')
            {
                params = JSON.parse(node.dataset.i18nParams);
                text = this._(node.dataset.i18n, params);
            }
            else
            {
                text = this._(node.dataset.i18n);
            }
            
            if(typeof(node.dataset.i18nTarget) != 'undefined')
            {
                node.setAttribute(node.dataset.i18nTarget, text);
            }
            else
            {
                node.innerHTML = text;
            }
        }
    }
});