/*
    --------------------------------------------------------------------
                             RMF RDS Widget
                Copyright (c) 2007-2012 Jacek Jędrzejewski
                    http://www.jacek.jedrzejewski.name/
                          All rights reserved.
    --------------------------------------------------------------------

    This file is part of RMF RDS Widget.
*/

function radioDebug(text)
{
    opera.postError('[PLAYER] '+text);
}

function radioMemory(memory)
{
    opera.postError('[MEMORY] '+(memory/1024/1024));
}

var Player = Base.extend({
    enabled: false,
    initialized: false,
    flashEnabled: false,
    wmpEnabled: false,
    
    $streaming: false,
    
    constructor: function(flashEnabled, wmpEnabled){
        this.enabled = flashEnabled || wmpEnabled;
        this.flashEnabled = flashEnabled;
        this.wmpEnabled = wmpEnabled;
        
        if(flashEnabled)
        {
            this.$streaming = $('#handle object')[0];
        }
    },
    
    initialize: function(url, volume, start, callback){
        var that = this;
        if(this.flashEnabled)
        {
            setTimeout(function(){
                if(!that.$streaming.configure)
                {
                    that.enabled = false;
                    that.flashEnabled = false;
                    that.wmpEnabled = false;
                    
                    widget.showNotification(I18N._('configure_flash'), function(){
                        widget.openURL('http://www.macromedia.com/support/documentation/en/flashplayer/help/settings_manager04.html#117502');
                    });
                    
                    return false;
                }
                
                that.$streaming.configure({
                    //'memoryMonitorCallback': 'radioMemory',
                    //'titleChangeCallback': 'radioTitle',
                    //'bufferingCallback': 'radioBuffering',
                    //'completeCallback': 'radioComplete',
                    //'errorCallback': 'radioError',
                    'volume': volume/100,
                    'streamAddress': url+'.mp3',
                    'maxMemory': 50,
                    'debug': false,
                    'debugTraceCallback': 'radioDebug'
                });
                that.initialized = true;
                
                if(start)
                {
                    that.$streaming.radioPlay();
                }
                
                callback();
            }, 1000);
        }
        else if(this.wmpEnabled)
        {
            document.streaming.URL = url+'.mp3.m3u';
            document.streaming.settings.volume = volume;
            
            if(start)
            {
                document.streaming.controls.play();
            }
            else
            {
                document.streaming.controls.stop();
            }
            
            this.initialized = true;
            callback();
        }
    },
    
    setURL: function(URL){
        if(!this.initialized)
        {
            return false;
        }
        
        if(this.flashEnabled)
        {
            this.$streaming.radioStream(URL+'.mp3');
            
            if(Rds.musicState == 'stop')
            {
                this.$streaming.radioStop();
            }
            if(Rds.musicState == 'play')
            {
                this.$streaming.radioPlay();
            }
        }
        else if(this.wmpEnabled)
        {
            document.streaming.URL = URL+'.mp3.m3u';
            
            if(Rds.musicState == 'stop')
            {
                document.streaming.controls.stop();
            }
            if(Rds.musicState == 'play')
            {
                document.streaming.controls.play();
            }
        }
    },
    
    stop: function(){
        if(!this.initialized)
        {
            return false;
        }
        
        if(this.flashEnabled)
        {
            this.$streaming.radioStop();
        }
        else if(this.wmpEnabled)
        {
            document.streaming.controls.stop();
        }
    },
    
    play: function(){
        if(!this.initialized)
        {
            return false;
        }
        
        if(this.flashEnabled)
        {
            this.$streaming.radioPlay();
        }
        else if(this.wmpEnabled)
        {
            document.streaming.controls.play();
        }
    },
    
    setVolume: function(volume){
        if(!this.initialized)
        {
            return false;
        }
        
        if(this.flashEnabled)
        {
            this.$streaming.radioVolume(volume/100);
        }
        else if(this.wmpEnabled)
        {
            document.streaming.settings.volume = volume;
        }
    }
});