/*
    --------------------------------------------------------------------
                             RMF RDS Widget
                Copyright (c) 2007-2012 Jacek Jędrzejewski
                    http://www.jacek.jedrzejewski.name/
                          All rights reserved.
    --------------------------------------------------------------------

    This file is part of RMF RDS Widget.
*/

/* I like setInterval and setTimeout from JavaScript, so here we have them */

package rds;

import haxe.Timer;

/**
 *
 * @author Tony Polinelli <touchmypixel.com>
 */
class GlobalTimer
{
    public static var timers:Array<Timer> = new Array();

    public static function setInterval(func:Dynamic, milliseconds:Int, rest:Array<Dynamic>):Int
    {
        var timer:Timer = new Timer(milliseconds);
        
        timers.push(timer);
        var id = timers.length - 1;
        
        timer.run = function(){
            Reflect.callMethod(null, func, rest);
        }
        
        return id;
    }

    public static function clearInterval(id:Int)
    {
        timers[id].stop();
        timers[id] = null;
    }

    public static function setTimeout(func:Dynamic, milliseconds:Int, rest:Array<Dynamic>):Int
    {
        var timer:Timer = new Timer(milliseconds);
        
        timers.push(timer);
        var id = timers.length-1;
        
        timer.run = function(){
            Reflect.callMethod(null, func, rest);
            clearTimeout(id);
        }
        
        return id;
    }

    public static function clearTimeout(id:Int)
    {
        timers[id].stop();
        timers[id] = null;
    }
}
